package com.gx.obe.common.file.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.shell.FileDownloadShell;
import com.gx.obe.common.file.thread.CheckHttpBidFileThread;
import com.gx.obe.common.file.thread.DownloadBidFileThread;
import com.gx.obe.common.file.thread.NewDownloadBiddingFileThread;
import com.gx.obe.common.file.utils.ZipUtils;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.TransactionServer;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 投标人投标加密标书下载界面
 * @author guoyr
 */
public class DownLoadEncBidFileComposite extends Composite {

	private TenderProjectEntity tenderProjectEntity;
	private Menu menu;
	private Grid supplierGrid;
	private SupplierService supplierService = new SupplierService();
	private ProjectRuleService projectRuleService ;
	private TenderProjectService tenderProjectService ;
	private String supplierName;
	// private GButton selectOkBtn;
	private List<Supplier> selectSupplierList;
	private String supplierId;
	private Button zbFileBtn;
	private Label zbFileMessage;
	private ExecutorService executorService;
	private CLabel messageLabel;
	private DownloadBidFileThread bidFileDownloadThread = null;
	private BigButton download_btn;
//	private ActionListener actionListener;
	private NewDownloadBiddingFileThread biddingFileDownloadThread;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	// private Logger LOG = Logger.getLogger(DownLoadBidFileComposite.class);
	private List<Supplier> supplierList;
	private Action projectAction;
	private boolean allowImportBidFile = true;
	// 如果匿名显示
	private boolean isAnonymous = false;
	private Composite operatorComposite;
	private GridColumn supplierNameColumn;
	{
		LogUtils.logClass(DownLoadEncBidFileComposite.class);
	}

	/**
	 * @param parent
	 * @param style
	 */
	public DownLoadEncBidFileComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				cancelAction();
			}
		});

		this.projectAction = projectAction;
		
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		Composite container = new Composite(this, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		container.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.horizontalSpacing = 0;
		gl_container.marginHeight = 0;
		gl_container.verticalSpacing = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);

		Composite composite = new Composite(container, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(3, false);
		composite.setLayout(gl_composite);

		messageLabel = new CLabel(composite, SWT.NONE);
		messageLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		messageLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/note.png"));
		messageLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		messageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		messageLabel.setText(Messages.Tips_downEncryptBidFile);

		ELink button = new ELink(composite, SWT.NONE);
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				checkAllAction();
			}
		});
		button.setText(Messages.Button_selectAll);

		ELink button_1 = new ELink(composite, SWT.NONE);
		button_1.setText(Messages.Button_deselected);
		button_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				disCheckAllAction();
			}
		});

		Composite composite_2 = new Composite(container, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 1;
		gl_composite_2.horizontalSpacing = 1;
		gl_composite_2.marginHeight = 1;
		gl_composite_2.marginWidth = 1;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_2.setBackground(SWTResourceManager.getColor(211, 211, 211));

		Composite composite_1 = new Composite(composite_2, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 1;
		gl_composite_1.horizontalSpacing = 1;
		gl_composite_1.marginHeight = 1;
		gl_composite_1.marginWidth = 1;
		composite_1.setLayout(gl_composite_1);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));

		supplierGrid = new Grid(composite_1, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		supplierNameColumn = new GridColumn(supplierGrid, SWT.CHECK);
		supplierNameColumn.setText(Messages.Name);
		supplierNameColumn.setWidth(250);

		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn.setText(Messages.StateOfLocalFile);
		gridColumn.setWidth(100);

		ESepator downLabel = new ESepator(composite_1, SWT.SEPARATOR | SWT.HORIZONTAL);
		downLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		downLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		Composite buttonComposite = new Composite(composite_1, SWT.NONE);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_buttonComposite = new GridLayout(2, false);
		buttonComposite.setLayout(gl_buttonComposite);

		zbFileBtn = new Button(buttonComposite, SWT.CHECK);
		zbFileBtn.setText(MessageFormat.format(Messages.Button_downloadFormat, Messages.BiddingFile));

		zbFileMessage = new Label(buttonComposite, SWT.NONE);
		zbFileMessage.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		operatorComposite = new Composite(composite_2, SWT.NONE);
		operatorComposite.setLayout(new GridLayout(4, false));
		operatorComposite.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		operatorComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));

		download_btn = new BigButton(operatorComposite, SWT.NONE);
		download_btn.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		download_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				slectOkAction();
			}
		});
		download_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		download_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		GridData gd_savebutton_1 = new GridData(SWT.RIGHT, SWT.FILL, true, false, 1, 1);
		download_btn.setLayoutData(gd_savebutton_1);
		download_btn.setText(Messages.Button_downloadEncBidFile);

		ELink label_1 = new ELink(operatorComposite, SWT.NONE);
		label_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				importBidFileByProject();
			}
		});
		label_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setText(Messages.Button_importEncBidFile);
		menuFunctionUtils.addFunction(label_1, "IMPORT_ENC_PACKAGE");

		ELink label = new ELink(operatorComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportBidFileByProject();
			}
		});
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.Button_exportEncBidFile);
		menuFunctionUtils.addFunction(label, "EXPORT_ENC_PACKAGE");

		ELink export_label = new ELink(operatorComposite, SWT.NONE);
		export_label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		export_label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		export_label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"));
		export_label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportBidFile();
			}
		});
		export_label.setText(Messages.Button_exportDecFile);
		menuFunctionUtils.addFunction(export_label, "EXPORT_DEC_FILE");
		tenderProjectService = new TenderProjectService();

		init();

	}
	/**
	 * @Description: 界面数据初始化
	 * @author guoyr
	 */
	private void init() {
		this.tenderProjectEntity = projectAction.getTenderProject();
		this.menu = projectAction.getMenu();
		supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		supplierNameColumn.setText(MessageFormat.format(Messages.NameFormat, supplierName));
		projectRuleService = new ProjectRuleService();
		allowImportBidFile = PropertiesUtils.getProperty(ConfigConstants.ALLOW_IMPORT_BIDFILE, "01").equals("01");
		

		// 右键菜单
		supplierGrid.addListener(SWT.Selection, new GridSelectionListener() {
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
		});
		// 双击打开
		supplierGrid.addSelectionListener(new SelectionAdapter() {
			public void widgetDefaultSelected(SelectionEvent e) {
				GridItem[] items = supplierGrid.getSelection();
				if (null != items && items.length > 0) {
					Supplier supplier = (Supplier) items[0].getData("supplier");
					if (null != supplier) {
						final String bidFilePath = FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId());
						final File bidFile = new File(bidFilePath);
						if(allowImportBidFile){
							if (!bidFile.exists()) {
								bidFile.mkdirs();
							}
						}
						if(bidFile.exists()){
							RuntimeUtils.openDirector(bidFilePath);
						}
					}
				}
			}
		});
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);
		refreshSupplierBidFile();
		download_btn.setEnabled(null == tenderProjectEntity.getBidOpeningStatus() || !tenderProjectEntity.getBidOpeningStatus().equals(CommonEnum.COMPLETE));// 项目完成开标不允许再去下载标书文件
		File biddingFileDir = new File(FileConstants.getBiddingFilePath(tenderProjectEntity.getId()));

		if (null != biddingFileDir && biddingFileDir.exists()) {
			zbFileMessage.setText(Messages.BiddingFile + "：" + FileUtils.getFileSize(FileUtils.getDirectorySize(biddingFileDir)));
			// 答疑文件
			File answerQuestionFolder = new File(FileConstants.getAnswerQuestionFilePath(tenderProjectEntity.getId()));
			long answerQuestionLength = FileUtils.getDirectorySize(answerQuestionFolder);
			if (null != answerQuestionFolder && answerQuestionFolder.exists() && answerQuestionLength > 0) {
				zbFileMessage.setText(zbFileMessage.getText() + "   "+Messages.ClarificationAnswerDocuments+"：" + FileUtils.getFileSize(answerQuestionLength));
			}
		} else {
			// zbFileMessage.setText("无招标文件");
			zbFileMessage.setText("");
		}
	
		
		// supplierGrid.addListener(SWT.Selection, new GridCheckedListener(true));
		
		menuFunctionUtils.initFunctionAuthority(menu, operatorComposite);
	}

	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction() {
		final EMenu gmenu = new EMenu(getShell());
		GridItem[] items = supplierGrid.getSelection();
		if (null != items && items.length > 0) {
			Supplier supplier = (Supplier) items[0].getData("supplier");
			if (null != supplier) {
				final String bidFilePath = FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId());
				final File bidFile = new File(bidFilePath);
				if(!allowImportBidFile && !bidFile.exists()){
					return;
				}

				gmenu.addMenuItem(Messages.Button_openDirectory, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
					public void click() {
						if(allowImportBidFile){
							if (!bidFile.exists()) {
								bidFile.mkdirs();
							}
						}
						if(bidFile.exists()){
							RuntimeUtils.openDirector(bidFilePath);
						}
					}
				});
				gmenu.open();
			}
		}
	}

	/**
	 * @Description: 刷新展示投标人投标文件列表
	 * @author guoyr
	 */
	private void refreshSupplierBidFile() {

		supplierList = supplierService.getAllSupplierList(tenderProjectEntity.getId());
		if (null != supplierList && supplierList.size() > 0) {
			isAnonymous = projectRuleService.isAnonymous(tenderProjectEntity.getId());
			final TransactionServer transactionServer = HttpUtils.getTransactionServer(tenderProjectEntity.getTransactionServerId());
			List<Future<?>> resultList = new ArrayList<Future<?>>();
			final TenderProjectEntity parentProject = null != tenderProjectEntity.getParentId() ? tenderProjectService.getById(tenderProjectEntity.getParentId()): null;
			executorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					int index = 1;
					for (final Supplier supplier : supplierList) {
						// 设置匿名和序号
						supplier.setAnonymous(isAnonymous, index);
						final GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
						gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
						gridItem.setData("supplierId", supplier.getId());
						gridItem.setData("supplier", supplier);
						gridItem.setText(0, index + "、" + supplier.getSupplierName());
						if (allowImportBidFile) {
							gridItem.setToolTipText(0, Messages.Tips_openDirectory);
						}
						if ((null != supplier.getBidFileDownloadTime())) {
							gridItem.setText(1, Messages.Tips_downloaded);
						} else {
							gridItem.setText(1, "--");
						}
						gridItem.setCheckable(0, false);
						gridItem.setGrayed(0, true);
						if (null != transactionServer) {
							gridItem.setText(1, Messages.Tips_gettingEncryptedBidInfo);
							resultList.add(executorService.submit(checkBidFile(transactionServer, parentProject, supplier, gridItem)));
						} else {
							gridItem.setText(1, Messages.Tips_FailedToConnectServer);
							gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
						}
						index++;
					}
					executorService.shutdown();
				}
			});
		}
	}

	/**
	 * /**
	 * 
	 * @Description: 校验投标人投标信息
	 * @author guoyr
	 * @param transactionServer
	 * @param parentProject
	 * @param supplier
	 * @param gridItem
	 * @return
	 */
	private CheckHttpBidFileThread checkBidFile(TransactionServer transactionServer, TenderProjectEntity parentProject, final Supplier supplier, final GridItem gridItem) {

		CheckHttpBidFileThread checkSupplierBidFileThread = new CheckHttpBidFileThread(transactionServer, parentProject, tenderProjectEntity, supplier, false, TenderProjectEnum.STAGE_ALL, new CheckHttpBidFileThread.CheckCallBack() {
			
			final long localBidFileSize = FileUtils.getDirectorySize(FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId()));
			
			public void bidFile(final boolean hasbidFile, final Date tenderTime, final long bidFileSize, String downUrl) {
				// 临时将下载地址放入申请地址，申请地址已不使用
				supplier.setApplyUrl(downUrl);
				supplier.setFileSize(bidFileSize);
				// 先验证是否已经下载了标书，且已下载的就是最新的标书，则不需要重复下载
				if (hasbidFile && null != tenderTime && bidFileSize > 0) {
					supplier.setTenderTime(tenderTime);
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setCheckable(0, true);
								gridItem.setGrayed(0, false);
								gridItem.setToolTipText(1, "本地文件" + FileUtils.getFileSize(localBidFileSize));
								gridItem.setData("supplier", supplier);
								setMessate(true);
								gridItem.setChecked(0, true);
								gridItem.setText(1, FileUtils.getFileSize(bidFileSize));
								gridItem.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								setMessate(false);
								gridItem.setData("supplier", supplier);
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setToolTipText(1, "本地文件" + FileUtils.getFileSize(localBidFileSize));
								gridItem.setText(1, "未在线投递");
							}
						}
					});
				}
			}

			public void callBackString(final String returnMessage) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!messageLabel.isDisposed()) {
							setMessate(false);
							gridItem.setText(1, Messages.Tips_FailedToConnectServer);
							gridItem.setToolTipText(1, "本地文件" + FileUtils.getFileSize(localBidFileSize));
							messageLabel.setText(returnMessage);
						}
					}
				});
			}
		});
		return checkSupplierBidFileThread;
	}

	private synchronized void setMessate(boolean needDownload) {
		if (needDownload) {
		}
//		messageLabel.setText("共检测到".concat(totalCount + "份").concat("文件需要下载！"));
	}

	/**
	 * @Description: 点击确认按钮 事件
	 * @author guoyr
	 */
	private void slectOkAction() {
		boolean downBiddingFile = zbFileBtn.getSelection();
		if (download_btn.getEnabled()) {
			selectSupplierList = GridUtils.getCheckedValues(supplierGrid, 0, "supplier");
			if (downBiddingFile || selectSupplierList.size() > 0) {
				if (selectSupplierList.size() > 0) {
					supplierService.batchUpdateProperty(selectSupplierList, new String[]{"tenderTime"});
					for (Supplier supplier : selectSupplierList) {
						FileDownloadShell.getInstance().httpBidDownload(tenderProjectEntity, supplier, null);
					}
				}
				// 如果选中下载招标文件
				if (downBiddingFile) {
					FileDownloadShell downloadShell = FileDownloadShell.getInstance();
					downloadShell.httpBiddingDownload(tenderProjectEntity);
				}
			} else {
				MessageDialog.openInformation(getShell(), MessageFormat.format(Messages.Tips_pleaseSelectDownloadFormat, Messages.BidDocument));
			}
		}
	}

	/**
	 * @Description: 导出标书
	 * @author guoyr
	 */
	private void exportBidFileByProject() {
		File file = new File(FileConstants.getBidFilePath(tenderProjectEntity.getId()));
		if (!file.exists() || file.listFiles().length <= 0) {
			MessageDialog.openError(getShell(), Messages.Tips_noBidFilePresent);
			return;
		}
		final String selectDir = FileDialogUtils.getDirectorySavePath(Messages.Tips_selectExportDic, "[" + tenderProjectEntity.getTenderNo() + "]" + tenderProjectEntity.getTenderName());
		if (!StringUtils.isNotEmpty(selectDir)) {
			return;
		}
		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage(Messages.Tips_exportingAndWaiting);
				final String saveDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProjectEntity.getTenderNo() + "]") + tenderProjectEntity.getTenderName() + ".zip";
				File zipFile = new File(saveDir);
				try {
					List<String> zipFileList = new ArrayList<String>();
					zipFileList.add(FileConstants.getBidFilePath(tenderProjectEntity.getId()));
					ZipUtils.zip((String[]) zipFileList.toArray(new String[zipFileList.size()]), zipFile.getAbsolutePath(), "评标结果", false, null);
				} catch (Exception e) {
				}
				File file = new File(saveDir);
				if (file.exists()) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							dialog.showMessage(Messages.Tips_exportSuccess);
							dialog.close();
							if (MessageDialog.openConfirm(getShell(), Messages.Button_openDirectory, Messages.Tips_exportAndOpenDirectory, new String[]{Messages.Button_open, Messages.Button_close})) {
								RuntimeUtils.openDirector(saveDir);
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openError(getShell(), Messages.Tips_noBidFileCanBeExport);
							dialog.close();
						}
					});
				}
			}
		}).start();
		dialog.open();
	}

	/**
	 * @Description: 导入加密标书
	 * @author guoyr
	 */
	public void importBidFileByProject() {
		final String filePath = FileDialogUtils.getFileNames(SWT.SINGLE, "选择标书文件", new String[] {"[" + tenderProjectEntity.getTenderNo() + "]*"+FileConstants.ETB+";[" + tenderProjectEntity.getTenderNo() + "]*"+".zip", "*"+FileConstants.ETB+";*"+".zip" }, new String[] {"[" + tenderProjectEntity.getTenderNo() + "]*", "所有标书" });
		if (!StringUtils.isNotEmpty(filePath)) {
			return;
		}
		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage("正在解压标书，请稍后。。。。。。");
				if(ZipUtils.unZip(filePath, FileConstants.getBidFilePath(tenderProjectEntity.getId()), true, false, true, null)) {
					dialog.showMessage("导入成功！");
				}else {
					dialog.showMessage("导入失败！");
				}
				dialog.finish();
			}
		}).start();
		dialog.open();
	}

	/**
	 * @Description: 取消按钮事件
	 * @author guoyr
	 */
	private void cancelAction() {
		if (null != executorService) {
			executorService.shutdownNow();
		}
		if (null != bidFileDownloadThread) {
			bidFileDownloadThread.stop();
		}
		if (null != biddingFileDownloadThread) {
			biddingFileDownloadThread.stop();
		}
	}

	public List<Supplier> getSelectSupplierList() {
		return selectSupplierList;
	}

	public String getSupplierId() {
		return supplierId;
	}

	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}

	private void checkAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			if (gridItem.getCheckable(0)) {
				gridItem.setChecked(0, true);
			}
		}
	}

	private void disCheckAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			gridItem.setChecked(0, false);
		}
	}

	public void addActionListener(ActionListener actionListener) {
//		this.actionListener = actionListener;
	}

	/**
	 * @Description: 导出投标文件
	 * @author guoyr
	 */
	private void exportBidFile() {
		File file = new File(FileConstants.getBidFilePath(tenderProjectEntity.getId()));
		if (!file.exists() || file.listFiles().length <= 0) {
			MessageDialog.openError(getShell(), Messages.Tips_noBidFilePresent);
			return;
		}
		// final List<Supplier> selectionSupplierList = getSelectionSupplier();
		// if(selectionSupplierList.size() == 0 ){
		// MessageDialog.openShortMessage("请选择要导出标书的"+supplierName);
		// return ;
		// }
		final String selectDir = FileDialogUtils.getDirectorySavePath(Messages.Tips_selectExportDic, "[" + tenderProjectEntity.getTenderNo() + "]" + tenderProjectEntity.getTenderName());
		if (!StringUtils.isNotEmpty(selectDir)) {
			return;
		}
		// 判断当前是否选择上传投标文件文件
		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		final CallBack callBack = dialog.getCallBack();
		new Thread(new Runnable() {
			public void run() {
				final String saveDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProjectEntity.getTenderNo() + "]") + tenderProjectEntity.getTenderName();
				if (null != supplierList && supplierList.size() > 0) {
					for (Supplier supplier : supplierList) {
						List<BidFile> bidFileList = BidFile.getSupplierBidFileList(tenderProjectEntity.getId(), supplier.getId(), null);
						if (null != bidFileList && bidFileList.size() > 0) {
							for (BidFile bidFile : bidFileList) {
								callBack.callBackString("正在导出" + supplier.getSupplierName() + "标书...");
								String bidFileName = bidFile.getName().substring(bidFile.getName().lastIndexOf("."));
								String target = saveDir.concat(File.separator).concat(supplier.getSupplierName()).concat(File.separator).concat(bidFile.getSimpleName()).concat(bidFileName);
								FileUtils.copy(bidFile.getAbsolutePath(), target);
								callBack.callBackString("   " + MessageFormat.format(Messages.Tips_exportSuccessFormat, bidFile.getSimpleName()));
							}
						} else {
							callBack.callBackString(supplier.getSupplierName() + Messages.Tips_noBidFileCanBeExport);
						}
					}
				}
				File file = new File(saveDir);
				if (file.exists()) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							dialog.showMessage(Messages.Tips_exportSuccess);
							dialog.close();
							if (MessageDialog.openConfirm(getShell(), Messages.Button_openDirectory, MessageFormat.format(Messages.Tips_exportAndOpenDirectoryFormat, Messages.BidFile), new String[]{Messages.Button_openDirectory, Messages.Button_close})) {
								RuntimeUtils.openDirector(saveDir);
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openError(getShell(), Messages.Tips_noBidFileCanBeExport);
							dialog.close();
						}
					});
				}
			}
		}).start();
		dialog.open();
	}
}
