package com.gx.obe.common.file.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuEnum;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.file.adapter.ExportBidFileAdapter;
import com.gx.obe.common.file.dialog.ClearProjectBidFileDialog;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.shell.FileDownloadShell;
import com.gx.obe.common.file.thread.CheckFtpBidFileThread;
import com.gx.obe.common.file.thread.CheckFtpBidFileThread.CheckCallBack;
import com.gx.obe.common.file.thread.CheckHttpBidFileThread;
import com.gx.obe.common.file.thread.DownloadBidFileThread;
import com.gx.obe.common.file.utils.ZipUtils;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.RemoteFile;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.TransactionServer;
import com.gx.obe.web.entity.auth.AuthLoginRecordEntity;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.MenuService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.UserLoginRecordService;
import com.gx.security.SystemTool;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 投标人明文标书下载界面
 * @author guoyr
 */
public class DownloadDecBidFileComposite extends Composite {

	private TenderProjectEntity tenderProject;
	private Grid supplierGrid;
	private SupplierService supplierService =  new SupplierService();
 	private ProjectRuleService projectRuleService ;
	private TenderProjectService tenderProjectService ;
	private String supplierName = Messages.Supplier;
	private List<Supplier> selectSupplierList;
	private String supplierId;
	private ExecutorService executorService;
	// private CLabel messageLabel;
	// private int totalCount = 0;
	private DownloadBidFileThread bidFileDownloadThread = null;
	private BigButton download_btn;
	private List<Supplier> supplierList;
	private Composite bidOpeningStageComposite;
	private String BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
	private ImageButton curStageBtn;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private boolean isFtp;
	private Composite container;
	private Composite composite_4;
	private Button zbFileBtn;
	private Label zbFileMessage;
	private ExecutorService localExecutorService;
 	private Menu menu;
	private ELink export_label;
	private Composite buttonComposite;
	private MenuFunctionUtils menuFunctionUtils = new  MenuFunctionUtils();
	private ELink button_1;
	private ELink button;
	private TitleComposite titleComposite;
	private MenuService menuService;
	private Composite composite;
	{
		LogUtils.logClass(DownloadDecBidFileComposite.class);
	}

	/**
	 * @param parent
	 * @param style
	 * @param isFtp
	 */
	public DownloadDecBidFileComposite(Composite parent, TenderProjectEntity tenderProject, boolean isFtp, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				cancelAction();
			}
		});
		this.tenderProject = tenderProject;
		this.isFtp = isFtp;
		supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		container = new Composite(this, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		container.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.verticalSpacing = 0;
		gl_container.horizontalSpacing = 0;
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);

		bidOpeningStageComposite = new Composite(container, SWT.NONE);
		bidOpeningStageComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_top = new GridLayout(2, false);
		gl_composite_top.marginHeight = 0;
		gl_composite_top.marginWidth = 0;
		bidOpeningStageComposite.setLayout(gl_composite_top);
		bidOpeningStageComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		titleComposite = new TitleComposite(container, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		titleComposite.setTitle(Messages.Tips_downDecryptBidFile);
		
		button = titleComposite.addELink("SELECT_ALL");
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				checkAllAction();
			}
		});
		button.setText(Messages.Button_selectAll);

		button_1 = titleComposite.addELink("DISSELECT");
		button_1.setText(Messages.Button_deselected);
		button_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				disCheckAllAction();
			}
		});
		
		ELink addBidFileBtn = titleComposite.addELink("IMPORT_BID_FILE");
		addBidFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		addBidFileBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				addBidFileAtion();
			}
		});
		addBidFileBtn.setText(Messages.Button_importBidFile);

		composite_4 = new Composite(container, SWT.NONE);
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.verticalSpacing = 1;
		gl_composite_4.horizontalSpacing = 1;
		gl_composite_4.marginHeight = 1;
		gl_composite_4.marginWidth = 1;
		composite_4.setLayout(gl_composite_4);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_4.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		Composite composite_1 = new Composite(composite_4, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 1;
		gl_composite_1.horizontalSpacing = 1;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));

		supplierGrid = new Grid(composite_1, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);

		GridColumn gridColumn_1 = new GridColumn(supplierGrid, SWT.CHECK);
		gridColumn_1.setText(supplierName);
		gridColumn_1.setWidth(250);

		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn.setText(Messages.ServerFileInfo);
		gridColumn.setWidth(100);
		
		GridColumn gridColumn_2 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_2.setText(Messages.StateOfLocalFile);
		gridColumn_2.setWidth(100);

		ESepator downLabel = new ESepator(composite_1, SWT.SEPARATOR | SWT.HORIZONTAL);
		downLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		downLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		buttonComposite = new Composite(composite_1, SWT.NONE);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_buttonComposite = new GridLayout(2, false);
		buttonComposite.setLayout(gl_buttonComposite);
		menuFunctionUtils.addFunction(buttonComposite, "DOWNLOAD_BIDDING_FILE");

		
		zbFileBtn = new Button(buttonComposite, SWT.CHECK);
		zbFileBtn.setText(MessageFormat.format(Messages.Button_downloadFormat, Messages.BiddingFile));

		zbFileMessage = new Label(buttonComposite, SWT.NONE);
		zbFileMessage.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		composite = new Composite(composite_4, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite opComposite = new Composite(composite, SWT.NONE);
		RowLayout rl_opComposite = new RowLayout(SWT.HORIZONTAL);
		rl_opComposite.center = true;
		opComposite.setLayout(rl_opComposite);
		opComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		opComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		
		download_btn = new BigButton(opComposite, SWT.NONE);
		download_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		download_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				slectOkAction();
			}
		});
		download_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		download_btn.setText(Messages.Button_downloadDecBidFile);
		menuFunctionUtils.addFunction(download_btn, "DOWNLOAD_BID_FILE");
		
		ELink label_1 = new ELink(opComposite, SWT.NONE);
		label_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				importBidFileByProject();
			}
		});
		label_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_1.setToolTipText("可导入他人已下载好的标书！");
		label_1.setText(Messages.ImportBidFileBag);
		menuFunctionUtils.addFunction(label_1, "IMPORT_BID_FILE");
		
		
		ELink label = new ELink(opComposite, SWT.NONE);
		label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportBidFileByProject();
			}
		});
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setToolTipText("导出系统中已下的标书包，可供他人直接导入！");
		label.setText(Messages.ExportBidFileBag);
		menuFunctionUtils.addFunction(label, "EXPORT_BID_FILE");
		
		
		export_label = new ELink(opComposite, SWT.NONE);
		export_label.setToolTipText("导出转码后可识别的标书文件");
		export_label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		export_label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"));
		export_label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportDecryptBidFileByProject();
			}
		});
		export_label.setText(Messages.ExportClearBidFile);
		menuFunctionUtils.addFunction(export_label, "EXPORT_FILE");
		
		ELink clearFileLink = new ELink(opComposite, SWT.NONE);
		clearFileLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				clearBidFilesAction();
			}
		});
		clearFileLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		clearFileLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		clearFileLink.setToolTipText(Messages.ClearBidFile);
		clearFileLink.setText(Messages.ClearBidFile);
		menuFunctionUtils.addFunction(clearFileLink, "CLEAR_BID_FILE");
		
		init();
	}

	/**
	 * @Description: 界面数据初始化
	 * @author guoyr
	 */
	private void init() {
//		+"("+Messages.Tips_noNeedToWaitForDownload+")"
		titleComposite.layout();
		projectRuleService = new ProjectRuleService();
		tenderProjectService = new TenderProjectService();
		menuService = new MenuService();
		bidOpeningStageRefresh();
		if (isFtp) {
			ftpRefreshSupplierBidFile();
		} else {
			refreshSupplierBidFile();
		}
		SyncThread myThreadSet = new SyncThread(new SyncThread.Runnable() {
			public void run() {
				menu = menuService.getMenutByMenuCode(MenuEnum.DOWNLOAD_BID_FILE);
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						menuFunctionUtils.initFunctionAuthority(menu, titleComposite.getFunctionComposite());
						if(!export_label.getVisible()){
							// 项目经理可导出明文标书
							if(UserEnum.ROLE_TYPE_EVALUATION_MANAGER.equals(Constants.USER.getUserType()) || UserEnum.ROLE_SUPER_MANAGER.equals(Constants.USER.getUserType())){
								WidgetUtils.setControlVisible(export_label, true);
							}
						}
						download_btn.getParent().layout();
						composite.layout();
					}
				});
			}
		});
		myThreadSet.start();
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("OPEN_DIRECTORY")) || UserEnum.ROLE_TYPE_EVALUATION_MANAGER.equals(Constants.USER.getUserType()) || UserEnum.ROLE_SUPER_MANAGER.equals(Constants.USER.getUserType())) {
			// 右键菜单
			supplierGrid.addListener(SWT.Selection, new GridSelectionListener() {
				public void rightMouseButtonDown(GridItem item) {
					supplierMenuDetectAction();
				}
			});
			// 双击打开
			supplierGrid.addSelectionListener(new SelectionAdapter() {
				public void widgetDefaultSelected(SelectionEvent e) {
					GridItem[] items = supplierGrid.getSelection();
					if (null != items && items.length > 0) {
						Supplier supplier = (Supplier) items[0].getData("supplier");
						if (null != supplier) {
							final String bidFilePath = FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId());
							final File bidFile = new File(bidFilePath);
							if (!bidFile.exists()) {
								bidFile.mkdirs();
							}
							RuntimeUtils.openDirector(bidFilePath);
						}
					}
				}
			});
		}
	}

	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction() {
		final EMenu gmenu = new EMenu(getShell());
		GridItem[] items = supplierGrid.getSelection();
		if (null != items && items.length > 0) {
			Supplier supplier = (Supplier) items[0].getData("supplier");
			if (null != supplier) {
				final String bidFilePath = FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId());
				final File bidFile = new File(bidFilePath);
				gmenu.addMenuItem(Messages.Button_openDirectory, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
					public void click() {
						if (!bidFile.exists()) {
							bidFile.mkdirs();
						}
						// RuntimeUtils.openDirectorAndSelect(bidFilePath);
						RuntimeUtils.openDirector(bidFilePath);
					}
				});
				gmenu.open();
			}
		}
	}

	private void bidOpeningStageRefresh() {
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProject.getId());
		if (null != tenderProjectRuleEntity.getBidOpeningStage() && tenderProjectRuleEntity.getBidOpeningStage().equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_TWO_STAGE)) {
			ImageButton stageBusTec = createBidOpeningStageBtn(Messages.BusinessTechnologyBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC);
			createBidOpeningStageBtn(Messages.EconomicBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_PRICE);
			curStageBtn = stageBusTec;
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC;
			stageBusTec.setSelection(true);
		} else {
			bidOpeningStageComposite.dispose();
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
		}
		
	}

	/**
	 * @Description: ftp刷新展示投标人投标文件列表
	 * @author chenxw
	 */
	private void ftpRefreshSupplierBidFile() {
		// totalCount = 0;
		supplierGrid.removeAll();
		supplierList = supplierService.getOpenBidSuccessSupplier(tenderProject.getId());
		if (null != supplierList && supplierList.size() > 0) {
			// 如果匿名显示
			boolean isAnonymous = false;
			// 如果显示匿名，验证是否要匿名
			if (Constants.SHOW_ANONYMOUS) {
				isAnonymous = projectRuleService.isAnonymous(tenderProject.getId());
			}
			List<Future<?>> resultList = new ArrayList<Future<?>>();
			executorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			localExecutorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			int index = 1;
			for (final Supplier supplier : supplierList) {
				// 设置匿名和序号
				supplier.setAnonymous(isAnonymous, index);
				final GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
				gridItem.setData("supplierId", supplier.getId());
				gridItem.setData("supplier", supplier);
				gridItem.setText(0, index +"、"+supplier.getSupplierName());
				gridItem.setToolTipText(0, Messages.Tips_openDirectory);
//				if ((null != supplier.getBidFileDownloadTime())) {
//					gridItem.setText(1, "已下载标书");
//				} else {
//					gridItem.setText(1, "--");
//				}
				gridItem.setCheckable(0, false);
				gridItem.setGrayed(0, true);
				gridItem.setText(1, Messages.Tips_gettingDecryptedBidInfo);
				String username = "anonymous";
				String password = null;
				String hostname = PropertiesUtils.getProperty(ConfigConstants.FTP_IP, "");
				if(null == hostname || hostname.length() == 0){
					UserLoginRecordService service = new UserLoginRecordService();
					AuthLoginRecordEntity authLoginRecordEntity = service.getLoginRecordByTenderId(supplier.getTenderId());
					if(null != authLoginRecordEntity && null != authLoginRecordEntity.getIp() && authLoginRecordEntity.getIp().trim().length() > 0){
						hostname = authLoginRecordEntity.getIp();
					}
				}
				username = PropertiesUtils.getProperty(ConfigConstants.FTP_USERNAME, username);
				password = PropertiesUtils.getProperty(ConfigConstants.FTP_PASSWORD, null);
				String bidFilePath = FileConstants.BID_FILE_PATH;
				if (hostname.equals(SystemTool.getIp())) {
					return;
				}
				String remotedir = tenderProject.getId().concat(File.separator).concat(FileConstants.BID_FILE_FOLDER).concat(File.separator).concat(supplier.getId());
				Future<?> future = executorService.submit(ftpCheckBidFile(supplier, hostname, username, password, remotedir, bidFilePath, gridItem));
				resultList.add(future);
				localExecutorService.submit(getLocalBidFileInfoThread(tenderProject, supplier, BIDOPENING_STAGE, gridItem));
				index ++;
			}
			if (null != executorService) {
				executorService.shutdown();
			}
			if (null != localExecutorService) {
				localExecutorService.shutdown();
			}
		}
	}

	/**
	 * @Description: 刷新展示投标人投标文件列表
	 * @author guoyr
	 */
	private void refreshSupplierBidFile() {
		// totalCount = 0;
		supplierGrid.removeAll();
		
		supplierList = supplierService.getOpenBidSuccessSupplier(tenderProject.getId());
		
		if (null != supplierList && supplierList.size() > 0) {
			// 如果匿名显示
			boolean isAnonymous = false;
			// 如果显示匿名，验证是否要匿名
			if (Constants.SHOW_ANONYMOUS) {
				isAnonymous = projectRuleService.isAnonymous(tenderProject.getId());
			}
			final TransactionServer transactionServer = HttpUtils.getTransactionServer(tenderProject.getTransactionServerId());
			TenderProjectEntity parentProject = null;
			if (null != transactionServer && null != tenderProject.getParentId()) {
				parentProject = (TenderProjectEntity) tenderProjectService.getById(tenderProject.getParentId());
			}
			List<Future<?>> resultList = new ArrayList<Future<?>>();
			final TenderProjectEntity _parentProject = parentProject;
			executorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			localExecutorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			int index = 1;
			for (final Supplier supplier : supplierList) {
				// 设置匿名和序号
				supplier.setAnonymous(isAnonymous, index);
				final GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
				gridItem.setData("supplierId", supplier.getId());
				gridItem.setData("supplier", supplier);
				gridItem.setText(0, index +"、"+supplier.getSupplierName());
				gridItem.setToolTipText(0, Messages.Tips_openDirectory);
//				if ((null != supplier.getBidFileDownloadTime())) {
//					gridItem.setText(1, "已下载标书");
//				} else {
//					gridItem.setText(1, "--");
//				}
				gridItem.setCheckable(0, false);
				gridItem.setGrayed(0, true);
//				if (bidOpeningComplate) {
//					gridItem.setCheckable(0, false);
//				} else {
//				}
				if (null != transactionServer && null != executorService) {
					gridItem.setText(1, Messages.Tips_gettingDecryptedBidInfo);
					Future<?> future = executorService.submit(checkBidFile(transactionServer, _parentProject, supplier, gridItem));
					resultList.add(future);
				} else {
					gridItem.setText(1, Messages.Tips_gettingDecryptedBidInfoFailed);
					gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
				}
				localExecutorService.submit(getLocalBidFileInfoThread(tenderProject, supplier, BIDOPENING_STAGE, gridItem));
				index ++;
			}
			if (null != executorService) {
				executorService.shutdown();
			}
			if (null != localExecutorService) {
				localExecutorService.shutdown();
			}
		}
	}

	/**
	 * @Description: 获取本地文件状态线程
	 * @author chenxw
	 * @param tenderProjectEntity
	 * @param supplier
	 * @param BIDOPENING_STAGE
	 * @param gridItem
	 * @return 
	 */
	private Runnable getLocalBidFileInfoThread(final TenderProjectEntity tenderProject, final Supplier supplier, final String BIDOPENING_STAGE, final GridItem gridItem) {
		gridItem.setText(2, Messages.Tips_gettingDecryptedBidInfo);
		return new Runnable() {
			public void run() {
				final boolean isExists = BidFile.checkBidFileExists(FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId()), BIDOPENING_STAGE);
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							if (isExists) {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
								gridItem.setText(2, Messages.Exist);
							} else {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setText(2, Messages.NotExist);
							}
						}
					}
				});
			}
		};
	}
	
	private CheckFtpBidFileThread ftpCheckBidFile(final Supplier supplier, String hostname, String username, String password, String remotedir, String localDir, final GridItem gridItem) {
		CheckFtpBidFileThread bidFileThread = new CheckFtpBidFileThread(supplier, hostname, username, password, remotedir, localDir, BIDOPENING_STAGE, new CheckCallBack() {
			
			public void bidFile(final long totalSize, List<RemoteFile> downLoadFTPFiles) {
				if (null == downLoadFTPFiles || downLoadFTPFiles.size() == 0) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setText(1, Messages.Tips_noDecryptedFilesDetected);
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
							}
						}
					});
				} else {
					supplier.setTotalSize(totalSize);
					supplier.setDownLoadFTPFiles(downLoadFTPFiles);
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setCheckable(0, true);
								gridItem.setGrayed(0, false);
								gridItem.setText(1, FileUtils.getFileSize(totalSize));
								gridItem.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
							}
						}
					});
				}
			}

			public void callBackString(final String returnMessage) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							gridItem.setText(1, Messages.Tips_FailedToConnectServer);
							gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
						}
					}
				});
			}
		});
		return bidFileThread;
	}

	/**
	 * @Description: 校验投标人投标信息
	 * @author guoyr
	 * @param transactionServer
	 * @param parentProject
	 * @param supplier
	 * @param gridItem
	 * @return
	 */
	private CheckHttpBidFileThread checkBidFile(TransactionServer transactionServer, TenderProjectEntity parentProject, final Supplier supplier, final GridItem gridItem) {

		CheckHttpBidFileThread checkSupplierBidFileThread = new CheckHttpBidFileThread(transactionServer, parentProject, tenderProject, supplier, true, BIDOPENING_STAGE, new CheckHttpBidFileThread.CheckCallBack() {
			// private boolean downLoadFile = true;
			final long localBidFileSize = FileUtils.getDirectorySize(FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId()));

			public void bidFile(final boolean hasbidFile, final Date tenderTime, final long bidFileSize, String downUrl) {
				// 临时将下载地址放入申请地址，申请地址已不使用
				supplier.setApplyUrl(downUrl);
				supplier.setFileSize(bidFileSize);
				// 先验证是否已经下载了标书，且已下载的就是最新的标书，则不需要重复下载
				if (hasbidFile && null != tenderTime && bidFileSize > 0) {
					supplier.setTenderTime(tenderTime);
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setCheckable(0, true);
								gridItem.setGrayed(0, false);
								gridItem.setData("supplier", supplier);
								gridItem.setText(1, FileUtils.getFileSize(bidFileSize));
								if (bidFileSize > localBidFileSize) {
									gridItem.setChecked(0, true);
								} else {
									gridItem.setChecked(0, false);
								}
								gridItem.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setData("supplier", supplier);
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setText(1, Messages.Tips_noDecryptedFilesDetected);
							}
						}
					});
				}
			}

			public void callBackString(final String returnMessage) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							gridItem.setText(1, Messages.Tips_FailedToConnectServer);
						}
					}
				});
			}
		});
		return checkSupplierBidFileThread;
	}

	/**
	 * @Description: 点击确认按钮 事件
	 * @author guoyr
	 */
	private void slectOkAction() {
		if (download_btn.getEnabled()) {
			boolean downBiddingFile = zbFileBtn.getSelection();
			selectSupplierList = GridUtils.getCheckedValues(supplierGrid, 0, "supplier");
			if (!downBiddingFile && selectSupplierList.size() == 0) {
				MessageDialog.openInformation(getShell(), MessageFormat.format(Messages.Tips_pleaseSelectDownloadFormat, Messages.BidDocument));
				return;
			}
			FileDownloadShell downloadShell = FileDownloadShell.getInstance();
			if (selectSupplierList.size() > 0) {
				for (Supplier supplier : selectSupplierList) {
					if (isFtp) {
						downloadShell.ftpBidDownload(tenderProject, supplier, BIDOPENING_STAGE);
					} else {
						downloadShell.httpBidDownload(tenderProject, supplier, BIDOPENING_STAGE);
					}
				}
			}
			if (downBiddingFile) {
				if (isFtp) {
					downloadShell.ftpBiddingDownload(tenderProject);
				} else {
					downloadShell.httpBiddingDownload(tenderProject);
				}
			}
		}
	}

	/**
	 * @Description: 取消按钮事件
	 * @author guoyr
	 */
	private void cancelAction() {
		if (null != executorService) {
			executorService.shutdownNow();
		}
		if (null != bidFileDownloadThread) {
			bidFileDownloadThread.stop();
		}
	}

	public List<Supplier> getSelectSupplierList() {
		return selectSupplierList;
	}

	public String getSupplierId() {
		return supplierId;
	}

	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}

	private void checkAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			if (gridItem.getCheckable(0)) {
				gridItem.setChecked(0, true);
			}
		}
	}

	private void disCheckAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			gridItem.setChecked(0, false);
		}
	}

	/**
	 * @Description: 导出投标文件
	 * @author guoyr
	 */
//	private void exportBidFile() {
//		File file = new File(Constants.getBidFilePath(tenderProjectEntity.getId()));
//		if (!file.exists() || file.listFiles().length <= 0) {
//			MessageDialog.openError(getShell(), Messages.Tips_noBidFilePresent);
//			return;
//		}
//
//		// final List<Supplier> selectionSupplierList = getSelectionSupplier();
//		// if(selectionSupplierList.size() == 0 ){
//		// MessageDialog.openShortMessage("请选择要导出标书的"+supplierName);
//		// return ;
//		// }
//		final String selectDir = FileDialogUtils.getDirectorySavePath(Messages.Tips_selectExportDic, "[" + tenderProjectEntity.getTenderNo() + "]" + tenderProjectEntity.getTenderName());
//		if (!StringUtils.isNotEmpty(selectDir)) {
//			return;
//		}
//		//判断当前是否选择上传投标文件文件
//
//		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
//		final CallBack callBack = dialog.getCallBack();
//		new Thread(new Runnable() {
//			public void run() {
//				final String saveDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProjectEntity.getTenderNo() + "]") + tenderProjectEntity.getTenderName();
//				if (null != suupplierList && suupplierList.size() > 0) {
//					for (Supplier supplier : suupplierList) {
//						List<BidFile> bidFileList = BidFile.getSupplierBidFileList(tenderProjectEntity.getId(), supplier.getId(), null);
//						if (null != bidFileList && bidFileList.size() > 0) {
//							for (BidFile bidFile : bidFileList) {
//								callBack.callBackString("正在导出" + supplier.getSupplierName() + "标书...");
//								FileUtils.copy(bidFile.getAbsolutePath(), saveDir.concat(File.separator).concat(supplier.getSupplierName()).concat(File.separator).concat(bidFile.getSimpleName()).concat(bidFile.getName().substring(bidFile.getName().lastIndexOf("."))));
//								callBack.callBackString("   " + bidFile.getSimpleName() + "导出成功！");
//							}
//						} else {
//							callBack.callBackString(supplier.getSupplierName() + Messages.Tips_noBidFileCanBeExport);
//						}
//					}
//				}
//				File file = new File(saveDir);
//				if (file.exists()) {
//					Display.getDefault().syncExec(new Runnable() {
//						public void run() {
//							dialog.showMessage(Messages.Tips_exportSuccess);
//							dialog.close();
//							if (MessageDialog.openConfirm(getShell(), Messages.Button_openDirectory, Messages.Tips_exportAndOpenDirectory, new String[]{Messages.Button_open, Messages.Button_close})) {
//								RuntimeUtils.openDirector(saveDir);
//							}
//						}
//					});
//				} else {
//					Display.getDefault().syncExec(new Runnable() {
//						public void run() {
//							MessageDialog.openError(getShell(), Messages.Tips_noBiddingFileCanBeExport);
//							dialog.close();
//						}
//					});
//				}
//			}
//		}).start();
//		dialog.open();
//	}

	/**
	 * @Description: 开标阶段
	 * @author guoyr
	 * @param stageName
	 * @return
	 */
	private ImageButton createBidOpeningStageBtn(String stageName, final String stageType) {
		final ImageButton bidOpeningTitle = new ImageButton(bidOpeningStageComposite, SWT.NONE);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setLeftMargin(10);
		bidOpeningTitle.setTopMargin(5);
		bidOpeningTitle.setBottomMargin(5);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		bidOpeningTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		bidOpeningTitle.setBackgroundColor(SWTResourceManager.getColor(245, 245, 245));

		bidOpeningTitle.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		bidOpeningTitle.setActiveBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);

		bidOpeningTitle.setSelectionForeground(ColorConstants.SKIN_SELECTOIN_FOREGROUND);
		bidOpeningTitle.setSelectionBgColor(ColorConstants.SKIN_BG);
		bidOpeningTitle.setText(stageName);
		bidOpeningTitle.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				BIDOPENING_STAGE = stageType;
				if (null != curStageBtn && !curStageBtn.isDisposed()) {
					curStageBtn.setSelection(false);
				}
				curStageBtn = bidOpeningTitle;
				curStageBtn.setSelection(true);
				if (isFtp) {
					ftpRefreshSupplierBidFile();
				} else {
					refreshSupplierBidFile();
				}
				// showBidOpeningComposite();
			}
		});
		return bidOpeningTitle;
	}

	/**
	 * @Description: 导出标书
	 * @author guoyr
	 */
	private void exportBidFileByProject() {
		File file = new File(FileConstants.getBidFilePath(tenderProject.getId()));
		if (!file.exists() || file.listFiles().length <= 0) {
			MessageDialog.openError(getShell(), Messages.Tips_noBidFilePresent);
			return;
		}

		final String selectDir = FileDialogUtils.getDirectorySavePath(Messages.Tips_selectExportDic, "[" + tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
		if (!StringUtils.isNotEmpty(selectDir)) {
			return;
		}

		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage(Messages.Tips_exportingAndWaiting);
				final String saveDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProject.getTenderNo() + "]") + tenderProject.getId() + ".zip";
				File zipFile = new File(saveDir);
				try {
					List<String> zipFileList = new ArrayList<String>();
					zipFileList.add(FileConstants.getBidFilePath(tenderProject.getId()));
					ZipUtils.zip((String[]) zipFileList.toArray(new String[zipFileList.size()]), zipFile.getAbsolutePath(), "评标结果", false, null);
				} catch (Exception e) {
				}
				File file = new File(saveDir);
				if (file.exists()) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							dialog.showMessage(Messages.Tips_exportSuccess);
							dialog.close();
							if (MessageDialog.openConfirm(getShell(), Messages.Button_openDirectory, Messages.Tips_exportAndOpenDirectory, new String[]{Messages.Button_open, Messages.Button_close})) {
								RuntimeUtils.openDirector(saveDir);
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openError(getShell(), Messages.Tips_noBidFileCanBeExport);
							dialog.close();
						}
					});
				}
			}
		}).start();
		dialog.open();
	}
	
	private void exportDecryptBidFileByProject() {
		new ExportBidFileAdapter().exportFils(getShell(), tenderProject, supplierList);
	}
	
	/**
	 * @Description: 导入加密标书
	 * @author guoyr
	 */
	public void importBidFileByProject() {
		final String filePath = FileDialogUtils.getFileNames(SWT.SINGLE, "选择标书文件", new String[] {"[" + tenderProject.getTenderNo() + "]*"+FileConstants.ETB+";[" + tenderProject.getTenderNo() + "]*"+".zip", "*"+FileConstants.ETB+";*"+".zip" }, new String[] {"[" + tenderProject.getTenderNo() + "]*", "所有标书" });
		if (!StringUtils.isNotEmpty(filePath)) {
			return;
		}
		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage("正在执行解压缩文件，请稍后...");
				if(ZipUtils.unZip(filePath, FileConstants.getBidFilePath(tenderProject.getId()), true, true, true, null)) {
					dialog.showMessage("导入成功！");
				}else {
					dialog.showMessage("导入失败！");
				}
				dialog.finish();
			}
		}).start();
		dialog.open();
	}

	/**
	 * 解压完毕，比对标书文件，如果是最新的，则替换原来的旧标书文件
	 * 
	 * @param filePath
	 * @param tempFilePath
	 */
//	private void compareFileToRemove(String filePath, String tempFilePath) {
//		File oldFile = new File(filePath);
//		File tempFile = new File(tempFilePath);
//		File[] oldFileList = oldFile.listFiles();
//		File[] tempFileList = tempFile.listFiles();
//		for (File file : oldFileList) {
//			for (File temp : tempFileList) {
//				if (temp.getName().equals(file.getName())) {
//					File[] oldChildFileList = file.listFiles();
//					File[] tempChildFileList = temp.listFiles();
//					compareFile(oldChildFileList, tempChildFileList);
//				}
//			}
//		}
//		tempFile.delete();
//	}
//
//	private void compareFile(File[] oldChildFileList, File[] tempChildFileList) {
//		for (File file : oldChildFileList) {
//			for (File tempFile : tempChildFileList) {
//				if (file.getName().equals(tempFile.getName())) {
//					if (tempFile.lastModified() - file.lastModified() > 0) {
//						tempFile.renameTo(file);
//					}
//				}
//			}
//		}
//	}

//	public void addDownloadBidFileListener(DownloadBidFileListener downloadBidFileListener) {
//		this.downloadBidFileListener = downloadBidFileListener;
//	}

	/**
	 * 供应商添加标书事件
	 */
	private void addBidFileAtion(){
		if(supplierGrid.getSelectionCount() > 0) {
			GridItem[] items = supplierGrid.getSelection();
			if (null != items && items.length > 0) {
				Supplier supplier = (Supplier) supplierGrid.getSelection()[0].getData("supplier");
				final File supplierDir = new File(FileConstants.getBidFilePath(supplier.getTenderId(), supplier.getId()));
				File bidFileIndexFile = new File(supplierDir.getAbsolutePath().concat(File.separator).concat(FileConstants.BID_FILE_INDEX_XML));
				if(bidFileIndexFile.exists()) {
					MessageDialog.openShortMessage("当前供应商不允许单独导入新的标书文件！");
					return;
				}
				String selectFiles = FileDialogUtils.getFileNames(SWT.MULTI, "导入标书", new String[]{"*.*"});
				if(null != selectFiles){
					String[] filePathList = selectFiles.split(";");
					if(filePathList.length > 0) {
						
					}
					final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, filePathList.length * 10, new LoadingAdatper() {
						public void finish(boolean flag) {
							Display.getDefault().syncExec(new Runnable() {
								public void run() {
									if(!supplierGrid.isDisposed()) {
										if (isFtp) {
											ftpRefreshSupplierBidFile();
										} else {
											refreshSupplierBidFile();
										}
									}
								}
							});
						}
						
					});
					new Thread(new Runnable() {
						public void run() {
							if(!supplierDir.exists()) {
								supplierDir.mkdirs();
							}
							boolean importFlag = true;
							for(String filePath : filePathList){
								File importFile = new File(filePath);
								if(importFile.exists()) {
									messageProgress.message("正在导入" + importFile.getName(), 0);
									messageProgress.addProgress(2);
									if(FileUtils.copy(filePath, supplierDir.getAbsolutePath().concat(File.separator).concat(importFile.getName()))) {
										messageProgress.message(importFile.getName() +"成功！", 1);
									}else {
										messageProgress.message(importFile.getName() +"失败！", -1);
										importFlag = false;
									}
									messageProgress.addProgress(8);
								}
							}
							messageProgress.finish(importFlag);
						}
					}).start();
					messageProgress.open();
				}
			}
		}else {
			MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_pleaseSelect, supplierName));
		}
		
	}
	
	/**
	 * @Description: 清空项目标书缓存
	 * @author guoyr 
	 */
	private void clearBidFilesAction() {
		ClearProjectBidFileDialog dialog = new ClearProjectBidFileDialog(getShell(), tenderProject);
		dialog.open();
	}
}
