package com.gx.obe.common.file.composite;

import java.awt.event.ActionListener;
import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.MenuEnum;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.shell.FileDownloadShell;
import com.gx.obe.common.file.thread.CheckServiceBidFileThread;
import com.gx.obe.common.file.thread.DownloadBidFileThread;
import com.gx.obe.common.file.utils.ZipUtils;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.FileInfoEntity;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.MenuService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 投标人明文标书下载界面
 */
public class DownloadServiceBidFileComposite extends Composite {

	private TenderProjectEntity tenderProject;
	private Grid supplierGrid;
	private SupplierService supplierService =  new SupplierService();
 	private ProjectRuleService projectRuleService ;
	private String supplierName = Messages.Supplier;
	private List<Supplier> selectSupplierList;
	private String supplierId;
	private ExecutorService executorService;
	// private CLabel messageLabel;
	// private int totalCount = 0;
	private DownloadBidFileThread bidFileDownloadThread = null;
	private BigButton download_btn;
	private List<Supplier> supplierList;
	private Composite bidOpeningStageComposite;
	private String BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
	private ImageButton curStageBtn;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Composite container;
	private Composite composite_4;
	private Button zbFileBtn;
	private Label zbFileMessage;
	private ExecutorService localExecutorService;
 	private Menu menu;
	private Composite buttonComposite;
	private MenuFunctionUtils menuFunctionUtils = new  MenuFunctionUtils();
	private ELink button_1;
	private ELink button;
	private TitleComposite titleComposite;
	private MenuService menuService;
	{
		LogUtils.logClass(DownloadServiceBidFileComposite.class);
	}

	/**
	 * @param parent
	 * @param style
	 * @param isFtp
	 */
	public DownloadServiceBidFileComposite(Composite parent, TenderProjectEntity tenderProject, boolean isFtp, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				cancelAction();
			}
		});
		this.tenderProject = tenderProject;
		supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		container = new Composite(this, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		container.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.verticalSpacing = 0;
		gl_container.horizontalSpacing = 0;
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);

		bidOpeningStageComposite = new Composite(container, SWT.NONE);
		bidOpeningStageComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_top = new GridLayout(2, false);
		gl_composite_top.marginHeight = 0;
		gl_composite_top.marginWidth = 0;
		bidOpeningStageComposite.setLayout(gl_composite_top);
		bidOpeningStageComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		titleComposite = new TitleComposite(container, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		titleComposite.setTitle("请选择要下载的标书!");
		
		
		button = titleComposite.addELink("SELECT_ALL");
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				checkAllAction();
			}
		});
		button.setText(Messages.Button_selectAll);

		button_1 = titleComposite.addELink("DISSELECT");
		button_1.setText(Messages.Button_deselected);
		button_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				disCheckAllAction();
			}
		});

		composite_4 = new Composite(container, SWT.NONE);
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.verticalSpacing = 1;
		gl_composite_4.horizontalSpacing = 1;
		gl_composite_4.marginHeight = 1;
		gl_composite_4.marginWidth = 1;
		composite_4.setLayout(gl_composite_4);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_4.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		Composite composite_1 = new Composite(composite_4, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 1;
		gl_composite_1.horizontalSpacing = 1;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));

		supplierGrid = new Grid(composite_1, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);

		GridColumn gridColumn_1 = new GridColumn(supplierGrid, SWT.CHECK);
		gridColumn_1.setText(supplierName);
		gridColumn_1.setWidth(250);

		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn.setText(Messages.ServerFileInfo);
		gridColumn.setWidth(100);
		
		GridColumn gridColumn_2 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_2.setText(Messages.StateOfLocalFile);
		gridColumn_2.setWidth(100);

		ESepator downLabel = new ESepator(composite_1, SWT.SEPARATOR | SWT.HORIZONTAL);
		downLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		downLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);

		buttonComposite = new Composite(composite_1, SWT.NONE);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_buttonComposite = new GridLayout(2, false);
		buttonComposite.setLayout(gl_buttonComposite);
		menuFunctionUtils .addFunction(buttonComposite, "DOWNLOAD_BIDDING_FILE");

		
		zbFileBtn = new Button(buttonComposite, SWT.CHECK);
		zbFileBtn.setText(MessageFormat.format(Messages.Button_downloadFormat, Messages.BiddingFile));

		zbFileMessage = new Label(buttonComposite, SWT.NONE);
		zbFileMessage.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite composite_3 = new Composite(composite_4, SWT.NONE);
		composite_3.setLayout(new GridLayout(4, false));
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		composite_3.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_3.setBackgroundMode(SWT.INHERIT_FORCE);

		download_btn = new BigButton(composite_3, SWT.NONE);
		download_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		download_btn.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		download_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				slectOkAction();
			}
		});
		download_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		download_btn.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		download_btn.setText("下载标书!");
		new Label(composite_3, SWT.NONE);
		new Label(composite_3, SWT.NONE);
		new Label(composite_3, SWT.NONE);
 		init();
	}

	/**
	 * @Description: 界面数据初始化
	 */
	private void init() {
		projectRuleService = new ProjectRuleService();
		bidOpeningStageRefresh();
		refreshSupplierBidFile();
		SyncThread myThreadSet = new SyncThread(new SyncThread.Runnable() {
			public void run() {
				menu = menuService.getMenutByMenuCode(MenuEnum.DOWNLOAD_BID_FILE);
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						menuFunctionUtils.initFunctionAuthority(menu);
					}
				});
			}
		});
		myThreadSet.start();
		// 右键菜单
		supplierGrid.addListener(SWT.Selection, new GridSelectionListener() {
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
		});
		// 双击打开
		supplierGrid.addSelectionListener(new SelectionAdapter() {
			public void widgetDefaultSelected(SelectionEvent e) {
				GridItem[] items = supplierGrid.getSelection();
				if (null != items && items.length > 0) {
					Supplier supplier = (Supplier) items[0].getData("supplier");
					if (null != supplier) {
						final String bidFilePath = FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId());
						final File bidFile = new File(bidFilePath);
						if (!bidFile.exists()) {
							bidFile.mkdirs();
						}
						RuntimeUtils.openDirector(bidFilePath);
					}
				}
			}
		});
	}

	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction() {
		final EMenu gmenu = new EMenu(getShell());
		GridItem[] items = supplierGrid.getSelection();
		if (null != items && items.length > 0) {
			Supplier supplier = (Supplier) items[0].getData("supplier");
			if (null != supplier) {
				final String bidFilePath = FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId());
				final File bidFile = new File(bidFilePath);
				gmenu.addMenuItem(Messages.Button_openDirectory, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
					public void click() {
						if (!bidFile.exists()) {
							bidFile.mkdirs();
						}
						// RuntimeUtils.openDirectorAndSelect(bidFilePath);
						RuntimeUtils.openDirector(bidFilePath);
					}
				});
				gmenu.open();
			}
		}
	}

	private void bidOpeningStageRefresh() {
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProject.getId());
		if (null != tenderProjectRuleEntity.getBidOpeningStage() && tenderProjectRuleEntity.getBidOpeningStage().equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_TWO_STAGE)) {
			ImageButton stageBusTec = createBidOpeningStageBtn(Messages.BusinessTechnologyBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC);
			createBidOpeningStageBtn(Messages.EconomicBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_PRICE);
			curStageBtn = stageBusTec;
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC;
			stageBusTec.setSelection(true);
		} else {
			bidOpeningStageComposite.dispose();
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
		}
		
	}


	/**
	 * @Description: 刷新展示投标人投标文件列表
 	 */
	private void refreshSupplierBidFile() {
		// totalCount = 0;
		supplierGrid.removeAll();
		
		supplierList = supplierService.getSupplierByStatusList(tenderProject.getId(),CommonEnum.REAL_STATUS);
		
		if (null != supplierList && supplierList.size() > 0) {
			// 如果匿名显示
			boolean isAnonymous = false;
			// 如果显示匿名，验证是否要匿名
			if (Constants.SHOW_ANONYMOUS) {
				isAnonymous = projectRuleService.isAnonymous(tenderProject.getId());
			}
			List<Future<?>> resultList = new ArrayList<Future<?>>();
			executorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			localExecutorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			int index = 1;
			for (final Supplier supplier : supplierList) {
				// 设置匿名和序号
				supplier.setAnonymous(isAnonymous, index);
				final GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
				gridItem.setData("supplierId", supplier.getId());
				gridItem.setData("supplier", supplier);
				gridItem.setText(0, index +"、"+supplier.getSupplierName());
				gridItem.setToolTipText(0, Messages.Tips_openDirectory);
				gridItem.setCheckable(0, false);
				gridItem.setGrayed(0, true);
				gridItem.setText(1, "正在获取标书信息...");
				Future<?> future = executorService.submit(checkBidFile(tenderProject, supplier, gridItem));
				resultList.add(future);
				localExecutorService.submit(getLocalBidFileInfoThread(tenderProject, supplier, BIDOPENING_STAGE, gridItem));
				index ++;
			}
			if (null != executorService) {
				executorService.shutdown();
			}
			if (null != localExecutorService) {
				localExecutorService.shutdown();
			}
		}
	}

	/**
	 * @Description: 获取本地文件状态线程
 	 * @param tenderProjectEntity
	 * @param supplier
	 * @param BIDOPENING_STAGE
	 * @param gridItem
	 * @return 
	 */
	private Runnable getLocalBidFileInfoThread(final TenderProjectEntity tenderProject, final Supplier supplier, final String BIDOPENING_STAGE, final GridItem gridItem) {
		gridItem.setText(2, "正在获取标书信息...");
		return new Runnable() {
			public void run() {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						boolean isExists = false;
 						File file = new File(FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId()));
						if (file.exists() &&file.list().length > 0) {
							isExists = true;
						}
					//	;; BidFile.checkBidFileExists(Constants.getBidFilePath(tenderProject.getId(), supplier.getId()), BIDOPENING_STAGE);
						if (isExists) {
							gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
							gridItem.setText(2, Messages.Exist);
						} else {
							gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
							gridItem.setText(2, Messages.NotExist);
						}
					}
				});
			}
		};
	}
	
	/**
	 * @Description: 校验投标人投标信息
	 */
	private CheckServiceBidFileThread checkBidFile(TenderProjectEntity parentProject, final Supplier supplier, final GridItem gridItem) {

		CheckServiceBidFileThread checkSupplierBidFileThread = new CheckServiceBidFileThread( tenderProject, supplier, new CheckServiceBidFileThread.CheckCallBack() {
			final long localBidFileSize = FileUtils.getDirectorySize(FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId()));
			public void bidFile(boolean isExist,String returnMessage,long fileSize,List<FileInfoEntity> fileInfoEntityList) {
				if (isExist) {
 					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setCheckable(0, true);
								gridItem.setGrayed(0, false);
								gridItem.setData("supplier", supplier);
								 
								gridItem.setText(1, FileUtils.getFileSize(fileSize));
								if (fileSize > localBidFileSize) {
									gridItem.setChecked(0, true);
								} else {
									gridItem.setChecked(0, false);
								}
								gridItem.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setData("supplier", supplier);
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setText(1, "未检测到文件");
							}
						}
					});
				}
			}
		});
		return checkSupplierBidFileThread;
	}

	/**
	 * @Description: 点击确认按钮 事件
	 * @author guoyr
	 */
	private void slectOkAction() {
		if (download_btn.getEnabled()) {
			boolean downBiddingFile = zbFileBtn.getSelection();
			selectSupplierList = GridUtils.getCheckedValues(supplierGrid, 0, "supplier");
			if (selectSupplierList.size() == 0) {
				MessageDialog.openInformation(getShell(), MessageFormat.format(Messages.Tips_pleaseSelectDownloadFormat, Messages.BidDocument));
				return;
			}
			FileDownloadShell downloadShell = FileDownloadShell.getInstance();
			if (selectSupplierList.size() > 0) {
				for (Supplier supplier : selectSupplierList) {
					downloadShell.serviceHttpBidDownload(tenderProject, supplier, BIDOPENING_STAGE);
				}
			}
			if (downBiddingFile) {
				downloadShell.serviceHttpBiddingDownload(tenderProject, BIDOPENING_STAGE);
 			}
		}
	}

	/**
	 * @Description: 取消按钮事件
	 * @author guoyr
	 */
	private void cancelAction() {
		if (null != executorService) {
			executorService.shutdownNow();
		}
		if (null != bidFileDownloadThread) {
			bidFileDownloadThread.stop();
		}
	}

	public List<Supplier> getSelectSupplierList() {
		return selectSupplierList;
	}

	public String getSupplierId() {
		return supplierId;
	}

	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}

	private void checkAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			if (gridItem.getCheckable(0)) {
				gridItem.setChecked(0, true);
			}
		}
	}

	private void disCheckAllAction() {
		for (GridItem gridItem : supplierGrid.getItems()) {
			gridItem.setChecked(0, false);
		}
	}


	/**
	 * @Description: 开标阶段
	 * @author guoyr
	 * @param stageName
	 * @return
	 */
	private ImageButton createBidOpeningStageBtn(String stageName, final String stageType) {
		final ImageButton bidOpeningTitle = new ImageButton(bidOpeningStageComposite, SWT.NONE);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setLeftMargin(10);
		bidOpeningTitle.setTopMargin(5);
		bidOpeningTitle.setBottomMargin(5);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		bidOpeningTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		bidOpeningTitle.setBackgroundColor(SWTResourceManager.getColor(245, 245, 245));

		bidOpeningTitle.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		bidOpeningTitle.setActiveBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);

		bidOpeningTitle.setSelectionForeground(ColorConstants.SKIN_SELECTOIN_FOREGROUND);
		bidOpeningTitle.setSelectionBgColor(ColorConstants.SKIN_BG);
		bidOpeningTitle.setText(stageName);
		bidOpeningTitle.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				BIDOPENING_STAGE = stageType;
				if (null != curStageBtn && !curStageBtn.isDisposed()) {
					curStageBtn.setSelection(false);
				}
				curStageBtn = bidOpeningTitle;
				curStageBtn.setSelection(true);
				
					refreshSupplierBidFile();
			}
		});
		return bidOpeningTitle;
	}

	/**
	 * @Description: 导出标书
	 * @author guoyr
	 */
	private void exportBidFileByProject() {
		File file = new File(FileConstants.getBidFilePath(tenderProject.getId()));
		if (!file.exists() || file.listFiles().length <= 0) {
			MessageDialog.openError(getShell(), Messages.Tips_noBidFilePresent);
			return;
		}

		final String selectDir = FileDialogUtils.getDirectorySavePath(Messages.Tips_selectExportDic, "[" + tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
		if (!StringUtils.isNotEmpty(selectDir)) {
			return;
		}

		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage(Messages.Tips_exportingAndWaiting);
				final String saveDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProject.getTenderNo() + "]") + tenderProject.getId() + ".zip";
				File zipFile = new File(saveDir);
				try {
					List<String> zipFileList = new ArrayList<String>();
					zipFileList.add(FileConstants.getBidFilePath(tenderProject.getId()));
					ZipUtils.zip((String[]) zipFileList.toArray(new String[zipFileList.size()]), zipFile.getAbsolutePath(), "评标结果", false, null);
				} catch (Exception e) {
				}
				File file = new File(saveDir);
				if (file.exists()) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							dialog.showMessage(Messages.Tips_exportSuccess);
							dialog.close();
							if (MessageDialog.openConfirm(getShell(), Messages.Button_openDirectory, Messages.Tips_exportAndOpenDirectory, new String[]{Messages.Button_open, Messages.Button_close})) {
								RuntimeUtils.openDirector(saveDir);
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openError(getShell(), Messages.Tips_noBidFileCanBeExport);
							dialog.close();
						}
					});
				}
			}
		}).start();
		dialog.open();
	}

	/**
	 * @Description: 导入加密标书
	 * @author guoyr
	 */
	public void importBidFileByProject() {
		final String filePath = FileDialogUtils.getFileNames(SWT.SINGLE, "选择标书文件", new String[] {"[" + tenderProject.getTenderNo() + "]*"+FileConstants.ETB+";[" + tenderProject.getTenderNo() + "]*"+".zip", "*"+FileConstants.ETB+";*"+".zip" }, new String[] {"[" + tenderProject.getTenderNo() + "]*", "所有标书" });
		if (!StringUtils.isNotEmpty(filePath)) {
			return;
		}
		final MessageViewDialog dialog = new MessageViewDialog(getShell(), SWT.NONE);
		new Thread(new Runnable() {
			public void run() {
				dialog.showMessage("正在执行解压缩文件，请稍后。。。。。。");
				if(ZipUtils.unZip(filePath, FileConstants.getBidFilePath(tenderProject.getId()), true, true, true, null)) {
					dialog.showMessage("导入成功！");
				}else {
					dialog.showMessage("导入失败！");
				}
				dialog.finish();
			}
		}).start();
		dialog.open();
	}

	public void addActionListener(ActionListener listener) {

	}
	
}
