package com.gx.obe.common.file.composite;

import java.util.concurrent.ExecutorService;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.dialog.CancelDownloadDialog;
import com.gx.obe.common.file.download.infer.FileDownloadListener;
import com.gx.obe.common.file.download.infer.FileDownloadListener.DOWN_STATUS;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.inter.FileDownloadThreadInterface;
import com.gx.obe.common.file.listener.DownloadListener;
import com.gx.obe.common.file.listener.IFileDownload;
import com.gx.obe.common.file.shell.FileDownloadShell;
import com.gx.obe.common.file.shell.FileDownloadShell.DownListener;
import com.gx.obe.common.file.thread.FtpBidFileDownloadThread;
import com.gx.obe.common.file.thread.FtpBiddingFileDownloadThread;
import com.gx.obe.common.file.thread.HttpBidFileDownloadThread;
import com.gx.obe.common.file.thread.HttpBiddingFileDownloadThread;
import com.gx.obe.common.file.thread.ServiceBidFileDownloadThread;
import com.gx.obe.common.file.thread.ServiceBiddingFileDownloadThread;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class FileDownloadingComposite extends Composite implements IFileDownload {

	private Composite composite;
	private Label fileName_label;
	private Label downSizeLabel;
	private Label downTimeLabel;
	private Label file_speedLabel;
	private ProgressBar file_progressBar;
	private ImageButton button;
	private FileDownloadThreadInterface downloadRunnable;
	private DownloadListener downloadListener;
	private DownListener mainDownListener;
	private FileDownloadListener listener;
	private TenderProjectEntity tenderProject;
	private Supplier supplier;
	private String BIDOPENING_STAGE;
	private String fileName;
	private String fileSize;
	private String downloadTime;
	private String downloadType;
	private String bidFilePath;
	private ExecutorService executorService;
	protected boolean curIsDelete = false;

	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 */
	public FileDownloadingComposite(Composite parent, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		setBackgroundMode(SWT.INHERIT_FORCE);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				dispose();
			}
		});
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginWidth = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.marginHeight = 0;
		setLayout(gridLayout);

		ESepator topSep = new ESepator(this, SWT.NONE);
		topSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		topSep.setLineStyle(SWT.LINE_DOT);
		topSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 4, 1));

		Composite contentComposite = new Composite(this, SWT.NONE);
		contentComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_contentComposite = new GridLayout(5, false);
		gl_contentComposite.marginHeight = 0;
		contentComposite.setLayout(gl_contentComposite);

		fileName_label = new Label(contentComposite, SWT.WRAP);
		fileName_label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		fileName_label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		GridData gd_messageLabel = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_messageLabel.widthHint = 300;
		fileName_label.setLayoutData(gd_messageLabel);

		composite = new Composite(contentComposite, SWT.NONE);
		GridData gd_composite = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_composite.widthHint = 200;
		composite.setLayoutData(gd_composite);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);

		file_progressBar = new ProgressBar(composite, SWT.NONE);
		file_progressBar.setBackground(ColorConstants.SKIN_BG);
		GridData gd_progressBar = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_progressBar.heightHint = 3;
		file_progressBar.setLayoutData(gd_progressBar);

		downSizeLabel = new Label(composite, SWT.NONE);
		GridData gd_label = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_label.widthHint = 100;
		downSizeLabel.setLayoutData(gd_label);
		downSizeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL));
		downSizeLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		downSizeLabel.setText(Messages.Unknown + " / " + Messages.Unknown);

		downTimeLabel = new Label(composite, SWT.NONE);
		downTimeLabel.setAlignment(SWT.CENTER);
		downTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL));
		downTimeLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		GridData gd_label_1 = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_label_1.widthHint = 100;
		downTimeLabel.setLayoutData(gd_label_1);
		downTimeLabel.setText(Messages.Tips_timeUsed + "：");

		file_speedLabel = new Label(contentComposite, SWT.WRAP);
		GridData gd_speedLabel = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_speedLabel.widthHint = 90;
		file_speedLabel.setAlignment(SWT.CENTER);
		file_speedLabel.setLayoutData(gd_speedLabel);
		file_speedLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		file_speedLabel.setText("0.00B/S");

		button = new ImageButton(contentComposite, SWT.CHECK);
		button.setToolTipText("开始下载");
		button.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				download();
			}
		});
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_start.png"));
		button.setSurroundMargin(0);
		button.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));

		ImageButton stopbutton = new ImageButton(contentComposite, SWT.CHECK);
		stopbutton.setToolTipText("取消下载");
		stopbutton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		stopbutton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				stopDownload();
			}
		});
		stopbutton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/error_circle.png"));
		stopbutton.setSurroundMargin(0);
		stopbutton.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
	}

	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	private void init() {
		if (DownloadListener.HTTP_BIDDING.equals(downloadType) || DownloadListener.SERVICE_BIDDING.equals(downloadType) ||DownloadListener.FTP_BIDDING.equals(downloadType)) {
			fileName = Messages.BiddingFile;
			bidFilePath = FileConstants.getBiddingFilePath(tenderProject.getId());
		} else {
			String BIDOPENING = "";
			if (TenderProjectEnum.STAGE_BUS_TEC.equals(BIDOPENING_STAGE)) {
				BIDOPENING = "-商务标、技术标";
			}
			if (TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE)) {
				BIDOPENING = "-经济标";
			}
			fileName = supplier.getSupplierName().concat(BIDOPENING);
			bidFilePath = FileConstants.getBidFilePath(tenderProject.getId(), supplier.getId());
		}
		fileName_label.setText(fileName);
		final FileDownloadingComposite downloadingComposite = this;
		listener = new FileDownloadListener() {
			public void downloadSuccess() {
				fileSize = listener.getFileSize();
				downloadTime = listener.getRuntime();
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {}
				if (null != downloadListener) {
					downloadListener.finish(downloadType, DOWN_STATUS.SUCCESS);
				}
				mainDownListener.downloadSuccess(tenderProject, downloadingComposite);
			}

			public void downloadFailed() {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!isDisposed()) {
							file_speedLabel.setText(Messages.Tips_failedDownload);
							file_speedLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
							fileName_label.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
							button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_redown.png"));
							button.setToolTipText(Messages.Tips_reDownload);
							MessageDialog.openRightBottomMessage(Messages.Tips_failedDownload, 5000);
						}
					}
				});
			}
			public void startDownload() {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!isDisposed()) {
							button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_pause.png"));
							button.setToolTipText(Messages.Tips_pauseToDownload);
						}
					}
				});
			}
		};
		if (DownloadListener.HTTP_BIDDING.equals(downloadType)) {
			downloadRunnable = new HttpBiddingFileDownloadThread(tenderProject, listener);
		} else if (DownloadListener.HTTP_BID.equals(downloadType)) {
			downloadRunnable = new HttpBidFileDownloadThread(tenderProject, supplier, BIDOPENING_STAGE, listener);
		} else if (DownloadListener.FTP_BIDDING.equals(downloadType)) {
			downloadRunnable = new FtpBiddingFileDownloadThread(tenderProject, listener);
		} else if (DownloadListener.FTP_BID.equals(downloadType)) {
			downloadRunnable = new FtpBidFileDownloadThread(supplier, listener);
		} else if (DownloadListener.SERVICE_HTTP_BID.equals(downloadType)) {
			downloadRunnable = new ServiceBidFileDownloadThread(tenderProject, supplier, listener);
		}else if(DownloadListener.SERVICE_BIDDING.equals(downloadType)) {
			downloadRunnable = new ServiceBiddingFileDownloadThread(tenderProject,listener);
		}
	}

	public void refresh(TenderProjectEntity tenderProject, Supplier supplier, String BIDOPENING_STAGE, String downloadType, ExecutorService executorService, DownloadListener downloadListener) {
		this.tenderProject = tenderProject;
		this.supplier = supplier;
		this.BIDOPENING_STAGE = BIDOPENING_STAGE;
		this.downloadType = downloadType;
		this.executorService = executorService;
		this.downloadListener = downloadListener;
		init();
		initDownload();
	}

	public void addMainDownloadListener(FileDownloadShell.DownListener mainDownListener) {
		this.mainDownListener = mainDownListener;
	}

	/**
	 * 下载的暂停和开始
	 * 
	 * @Description:
	 * @author chenxw
	 */
	private void download() {
		if (listener.getDownloadStatus() == DOWN_STATUS.START) {
			pauseDownload();
		} else if (listener.getDownloadStatus() == DOWN_STATUS.PAUSE) {
			startDownload();
		} else if (listener.getDownloadStatus() == DOWN_STATUS.FAIL) {
			restartDownload();
		}
	}

	/**
	 * @Description: 开始下载
	 * @author chenxw
	 */
	public void initDownload() {
		downloadRunnable.initDownload();
		executorService.submit(downloadRunnable.getRunnable());
		new Thread(downloadMessageRunnable).start();
//		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_pause.png"));
//		button.setToolTipText(Messages.Tips_pauseToDownload);
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_wait.png"));
		button.setToolTipText(Messages.Tips_waitingForDownload);
	}

	/**
	 * @Description: 继续下载
	 * @author chenxw
	 */
	public void startDownload() {
		if (null != downloadRunnable) {
			downloadRunnable.setDownloadStatus(DOWN_STATUS.START);
			button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_pause.png"));
			button.setToolTipText(Messages.Tips_pauseToDownload);
		}
	}

	/**
	 * @Description: 暂停下载
	 * @author chenxw
	 */
	private void pauseDownload() {
		if (null != downloadRunnable) {
			downloadRunnable.setDownloadStatus(DOWN_STATUS.PAUSE);
			button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_start.png"));
			button.setToolTipText("开始下载");
		}
	}

	/**
	 * @Description: 停止下载
	 * @author chenxw
	 */
	protected void stopDownload() {
		if (listener.getDownloadStatus() == DOWN_STATUS.START) {
			pauseDownload();
		}
		CancelDownloadDialog dialog = new CancelDownloadDialog(getShell());
		dialog.addConfirmListener(new CancelDownloadDialog.ConfirmListener() {
			public void confirm(boolean isDelete) {
				if(null != downloadRunnable){
					if (listener.getDownloadStatus() == DOWN_STATUS.PAUSE) {
						downloadRunnable.setDeleteDownloadFile(isDelete);
					} else if (listener.getDownloadStatus() == DOWN_STATUS.FAIL && isDelete) {
						downloadRunnable.deleteDownloadFile();
					}
					downloadRunnable.setDownloadStatus(DOWN_STATUS.CANCEL);
				}
				cancelDownload();
			}
		});
		dialog.open();
		if (listener.getDownloadStatus() == DOWN_STATUS.PAUSE) {
			startDownload();
		}
	}

	/**
	 * @Description: 重新开始下载
	 * @author chenxw
	 */
	public void restartDownload() {
		fileName_label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		file_speedLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		file_speedLabel.setText("0.00字节/S");
//		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_pause.png"));
//		button.setToolTipText(Messages.Tips_pauseToDownload);
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/download_wait.png"));
		button.setToolTipText(Messages.Tips_waitingForDownload);
		initDownload();
	}

	/** 
	 * @Description: 取消下载
	 * @author chenxw 
	 */
	public void closeDownloadTask() {
		downloadRunnable.setDownloadStatus(DOWN_STATUS.CANCEL);
	}
	
	protected void cancelDownload() {
		mainDownListener.cancelDownload(tenderProject, this);
	}
	
	Runnable downloadMessageRunnable = new Runnable() {
		final long sepTime = 1000;
		public void run() {
			while (true) {
				try {
					Thread.sleep(sepTime);
				} catch (InterruptedException e) {}
				if (listener.getDownloadStatus() == DOWN_STATUS.WAITE || listener.getDownloadStatus() == DOWN_STATUS.START || listener.getDownloadStatus() == DOWN_STATUS.PAUSE) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!isDisposed()) {
								file_speedLabel.setText(listener.getDownloadSpeed(sepTime));
								file_progressBar.setSelection((int) listener.getProgress());
								downSizeLabel.setText(listener.getDownloadedShare());
								downTimeLabel.setText(Messages.Tips_timeUsed + "：".concat(listener.getRuntime()));
							}
						}
					});
				} else {
					break;
				}
			}
		}
	};

	public String getBidFilePath() {
		return bidFilePath;
	}

	public String getFileName() {
		return fileName;
	}

	public String getFileSize() {
		return fileSize;
	}

	public String getDownloadTime() {
		return downloadTime;
	}

	protected void checkSubclass() {

	}

	public Supplier getSupplier() {
		return supplier;
	}

	public String getBidopeningStage() {
		return BIDOPENING_STAGE;
	}

}
