package com.gx.obe.common.file.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.file.composite.DownloadDecBidFileComposite;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.listener.SelectionTenderPackListener;
import com.gx.obe.common.widget.shell.SelectTenderPackShell;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.listener.WebEntityListener;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class DownloadDecBidFileDialog extends EDialog {

	private TenderProjectService tenderProjectService ;
	private TenderProjectEntity tenderProject;
	private DownloadDecBidFileComposite downloadDecBidFileComposite;
	private boolean isFtp;
	private Composite container;
	private Composite generalNameComposite;
	private Composite changePacketComposite;
	private Label projectName;
	private Label packName;
	private SelectionTenderPackListener selectionTenderPackListener;
	
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public DownloadDecBidFileDialog(Shell parentShell, TenderProjectEntity tenderProject, boolean isFtp){
		super(parentShell);
		tenderProjectService = new TenderProjectService();
		this.tenderProject = tenderProject;
		this.isFtp = isFtp;
		if (isFtp) {
			this.setTitle("局域网标书下载");
		} else {
			this.setTitle("网络标书下载");
		}
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	protected Control createDialogArea(Composite parent) {
		container = (Composite) super.createDialogArea(parent);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.verticalSpacing = 0;
		container.setLayout(gl_container);
		
		Composite composite_1 = new Composite(container, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 1;
		gl_composite_1.marginWidth = 0;
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		generalNameComposite = new Composite(composite_1, SWT.NONE);
		generalNameComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		generalNameComposite.setLayout(new GridLayout(1, false));
		generalNameComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		changePacketComposite = new Composite(composite_1, SWT.NONE);
		changePacketComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_changePacketComposite = new GridLayout(4, false);
		gl_changePacketComposite.marginHeight = 0;
		changePacketComposite.setLayout(gl_changePacketComposite);
		changePacketComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		projectName = new Label(generalNameComposite, SWT.WRAP);
		projectName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		projectName.setAlignment(SWT.CENTER);
		projectName.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		projectName.setFont(SWTResourceManager.getFont("微软雅黑", 14, SWT.BOLD));
		projectName.setForeground(SWTResourceManager.getColor(51, 51, 51));
		projectName.setText("");
		
		Label label = new Label(changePacketComposite, SWT.NONE);
		label.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		packName = new Label(changePacketComposite, SWT.WRAP);
		packName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		packName.setAlignment(SWT.CENTER);
		packName.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		packName.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		packName.setForeground(SWTResourceManager.getColor(100, 100, 100));
		packName.setText("");
		
		ELink changePackLink = new ELink(changePacketComposite, SWT.WRAP);
		changePackLink.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		changePackLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				changeTenderPackAction();
			}
		});
		changePackLink.setFont(SWTResourceManager.getFont("微软雅黑", 18, SWT.BOLD));
		changePackLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/switch_big.png"));
		changePackLink.setToolTipText(Messages.Button_change);
		
		Label label_1 = new Label(changePacketComposite, SWT.NONE);
		label_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		init();
		return container;
	}


	protected void changeTenderPackAction() {
		SelectTenderPackShell selectTenderPackShell = new SelectTenderPackShell(getShell(), tenderProject.getParentId() , tenderProject.getId(), selectionTenderPackListener);
		Point point = packName.toDisplay(0,packName.getBounds().height);
		selectTenderPackShell.setLocation(point);
		selectTenderPackShell.open();
	}
	class RefreshActionThread extends MyRunnable{
		private WebEntityListener<TenderProjectEntity> listener;
		private String id;
		private int iStatus;
		public RefreshActionThread(String id ,int iStatus,WebEntityListener<TenderProjectEntity> listener){
			this.listener = listener;	
			this.iStatus = iStatus;
			this.id = id;
		}
		@Override
		public void run() {
			TenderProjectEntity curTenderPack = tenderProjectService.getById(id);  
			if(iStatus == 1){
				TenderProjectEntity project = tenderProjectService.getById(curTenderPack.getParentId());
				curTenderPack.setParentProjectEntity(project);				
			}else if(iStatus == 2){
				curTenderPack = getFirstTenderPack(id);
			}
 			listener.run(curTenderPack);
		}
	}
	private void init(){
//		final TenderProjectEntity curTenderPack = null;
		if(null != tenderProject.getParentId()){
			RefreshActionThread  refreshActionThread = new RefreshActionThread(tenderProject.getId(),1, new WebEntityListener<TenderProjectEntity>() {	
				@Override
				public void run(final TenderProjectEntity entity) {
					final TenderProjectEntity project = entity.getParentProjectEntity(); 
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
				 			projectName.setText("[" + project.getTenderNo() + "]" + project.getTenderName());
							packName.setText("[" + entity.getTenderNo() + "]" + entity.getTenderName());
							changePacketComposite.layout();	
							getSelectionTenderPackListener();
							generalNameComposite.layout();
						} 
					});
				}
			});
			refreshActionThread.start();
		
		}else {
			projectName.setText("[" + tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
			// 带分包的项目
			if(null != tenderProject.getIsPack() && tenderProject.getIsPack().equals(CommonEnum.YES)){
				RefreshActionThread  refreshActionThread = new RefreshActionThread(tenderProject.getId(),2, new WebEntityListener<TenderProjectEntity>() {	
					@Override
					public void run(final TenderProjectEntity entity) {
 						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								packName.setText("[" + entity.getTenderNo() + "]" + entity.getTenderName());
								changePacketComposite.layout();
								getSelectionTenderPackListener();
								generalNameComposite.layout();
							} 
						});
					}
				});
				refreshActionThread.start();
			}else {
				WidgetUtils.setControlVisible(changePacketComposite, false);
			}
		}
		downloadDecBidFileComposite = new DownloadDecBidFileComposite(container, tenderProject, isFtp, SWT.NONE);
		downloadDecBidFileComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
	}
	
	/**
	 * @Description: 获得项目下的第一个包件
	 * @author guoyr 
	 */
	private TenderProjectEntity getFirstTenderPack(String projectId){
		Page<TenderProjectEntity> projectPage = tenderProjectService.getSubPackagePageList(projectId, SelectTenderPackShell.CUR_PAGE_NO, 6);
		if(null != projectPage && null != projectPage.getRecords() && projectPage.getRecords().size() > 0){
			TenderProjectEntity tenderProjectEntity = projectPage.getRecords().get(0);
			return tenderProjectEntity;
		}
		return tenderProject;
	}

	public void getSelectionTenderPackListener() {
		selectionTenderPackListener = new SelectionTenderPackListener(){
			public void selectPack(TenderProjectEntity tenderPack) {
				// 选择后重新查询一次
 				RefreshActionThread  refreshActionThread = new RefreshActionThread(tenderPack.getId(),0, new WebEntityListener<TenderProjectEntity>() {	
					@Override
					public void run(TenderProjectEntity entity) {
						Display.getDefault().syncExec(()->{
							if(!changePacketComposite.isDisposed()) {
								packName.setText("[" + entity.getTenderNo() + "]" + entity.getTenderName());
								changePacketComposite.layout();
								tenderProject = entity;
								if (null != downloadDecBidFileComposite && !downloadDecBidFileComposite.isDisposed()) {
									downloadDecBidFileComposite.dispose();
								}
								downloadDecBidFileComposite = new DownloadDecBidFileComposite(container, tenderProject, isFtp, SWT.NONE);
								downloadDecBidFileComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
								container.layout();
							}
						});
					}
				});
				refreshActionThread.start();
			}
		};
	}
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(799, 533);
	}

//	@Override
//	public void downloadSupplierBidFile(List<Supplier> selectSupplierList, String bIDOPENING_STAGE) {
//		close();
//		FileDownloadShell.getInstance().download(selectSupplierList, tenderProjectEntity, bIDOPENING_STAGE, isFtp, new FinishMessage() {
//			public void finish() {};
//		});
//	}
}
