package com.gx.obe.common.file.download;

import java.util.Map;
import java.util.concurrent.ExecutorService;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.common.file.download.infer.DownloadFileAdapter;
import com.gx.obe.common.file.download.infer.DownloadFileListener;
import com.gx.obe.common.file.download.infer.DownloadReportFile;
import com.gx.obe.common.file.download.infer.FileDownloadListener;
import com.gx.obe.common.widget.dialog.ProgressDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.http.util.Base64;

/** 
 * @Description: 文件工具类
 * @author mazc 
 */
public class DownloadFileUtill {
	
	private SiteFileFetch siteFileFetch;
	private boolean pause;
	
	/** 
	 * @author chenxw
	 * @param fileName
	 * @param filePath
	 * @param adapter 
	 */
	public DownloadFileUtill(String fileName, String filePath, DownloadFileAdapter adapter) {
		String URL = Constants.getServiceUrl("/download/downloadTemplateFile");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("fileName", fileName);
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
		InfoBean bean = new InfoBean(sb.toString(), filePath, fileName);
		siteFileFetch = new SiteFileFetch(bean, adapter);
	}
	
	
	public DownloadFileUtill(String fileName,String targetFileName, String filePath ,DownloadFileAdapter adapter) {
		String URL = Constants.getServiceUrl("/download/downloadSoftware");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("fileName", fileName);
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
		InfoBean bean = new InfoBean(sb.toString(), filePath, targetFileName);
		siteFileFetch = new SiteFileFetch(bean, adapter);
	}
	
	/** 
	 * @author mazc
 	 * @param fileURL 下载文件地址
	 * @param fileName 文件名称
	 * @param attributeMap 请求其他参数
	 * @param filePath 下载位置
	 */
	public DownloadFileUtill(String fileURL, String fileName,String filePath,int type){
		String URL = Constants.getServiceUrl("/YWRtaW5maWxl/download");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("path",Base64.encode(fileURL));
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
  		InfoBean bean = new InfoBean(sb.toString(),filePath,fileName);
		siteFileFetch = new SiteFileFetch(bean,null);
	}
	
	/** 
	 * @author mazc
 	 * @param fileURL 下载文件地址
	 * @param fileName 文件名称
	 * @param attributeMap 请求其他参数
	 * @param filePath 下载位置
	 */
	public DownloadFileUtill(String fileURL, String fileName, Map<String, String> attributeMap,String filePath ,DownloadFileListener listener,FileDownloadListener statuslistener){
		String URL = Constants.getServiceUrl("/download/downloadFile");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("fileURL",Base64.encode(fileURL));
		if(null != attributeMap ){
			for (Map.Entry<String, String> entry : attributeMap.entrySet()) {
				httpUrl.setAttribute(entry.getKey(),entry.getValue());
			}
		}	
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
  		InfoBean bean = new InfoBean(sb.toString(),filePath,fileName);
		siteFileFetch = new SiteFileFetch(bean,listener);
	}
	
 	/** 
	 * @author mazc
 	 * @param fileURL 下载文件地址
	 * @param fileName 文件名称
	 * @param attributeMap 请求其他参数
	 * @param filePath 下载位置
	 */
	public DownloadFileUtill(String fileURL, String fileName, Map<String, String> attributeMap,String filePath ,DownloadFileListener listener){
		String URL = Constants.getServiceUrl("/download/downloadFile");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("fileURL",Base64.encode(fileURL));
		if(null != attributeMap ){
			for (Map.Entry<String, String> entry : attributeMap.entrySet()) {
				httpUrl.setAttribute(entry.getKey(),entry.getValue());
			}
		}	
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
  		InfoBean bean = new InfoBean(sb.toString(),filePath,fileName);
		siteFileFetch = new SiteFileFetch(bean,listener);
	}
	
	/** 
	 * @author mazc
 	 * @param fileURL 下载文件地址
	 * @param fileName 文件名称
	 * @param attributeMap 请求其他参数
	 * @param filePath 下载位置
	 */
	public DownloadFileUtill(String fileURL, String fileName,String filePath ,DownloadFileListener listener){
		String URL = Constants.getServiceUrl("/download/downloadVideoFile");
		HttpUrl httpUrl = new HttpUrl(URL);
		httpUrl.setAttribute("fileURL",Base64.encode(fileURL));
	
		StringBuilder sb = new StringBuilder();
		sb.append(URL).append(httpUrl.getAttributs());
  		InfoBean bean = new InfoBean(sb.toString(),filePath,fileName);
		siteFileFetch = new SiteFileFetch(bean,listener);
		siteFileFetch.setPause(pause);
	}
	
    public static boolean startDownloadVideoFileSync(String fileURL, String fileName, String filePath, String message) {
        final ProgressDialog synchShell = new ProgressDialog(Display.getDefault().getActiveShell(), message);
        DownloadReportFile downloadReportFile = new DownloadReportFile() {
            private boolean downloadFlag;
            
            public void complate(boolean loginFlag) {
                this.downloadFlag = loginFlag;
                Display.getDefault().syncExec(new Runnable() {
                    public void run() {
                        synchShell.close();
                    }
                });
            }
            
            public boolean isDownload() {
                return downloadFlag;
            }
        };
        new DownloadFileUtill(fileURL, fileName, filePath, downloadReportFile).startDownloadFile();
        synchShell.open();
        return downloadReportFile.isDownload();
    }
	
	
	
	/**
	 * @Description: 开启阻塞下载文件
	 * @author chenxw
	 * @param fileURL
	 * @param fileName
	 * @param filePath 
	 * @param message 
	 */
    public static boolean startDownloadFileSync(String fileURL, String fileName, String filePath, String message) {
        final ProgressDialog synchShell = new ProgressDialog(null != Display.getDefault().getActiveShell() ? Display.getDefault().getActiveShell() : new Shell(), message);
        DownloadReportFile downloadReportFile = new DownloadReportFile() {
            private boolean downloadFlag;
            
            public void complate(boolean loginFlag) {
                this.downloadFlag = loginFlag;
                Display.getDefault().syncExec(new Runnable() {
                    public void run() {
                        synchShell.close();
                    }
                });
            }
            
            public boolean isDownload() {
                return downloadFlag;
            }
        };
        new DownloadFileUtill(fileURL, fileName, null, filePath, downloadReportFile).startDownloadFile();
        synchShell.open();
        return downloadReportFile.isDownload();
    }
	
	/**
	 * @Description: 启动文件下载
	 * @author mazc 
	 */
	public void startDownloadFile(){
		siteFileFetch.start();
	}
	/**
	 * @Description: join
	 * @author mazc 
	 */
	public void joinThread(){
		try {
			siteFileFetch.join();
		} catch (InterruptedException e) {
		};
	}
	
    /**
     * @Description: 启动文件下载
     * @author chenxw
     * @param executorService 
     */
    public void startDownloadFile(ExecutorService executorService){
        executorService.submit(siteFileFetch);
    }
	
	/**
	 * @Description: 停止文件下载
	 * @author mazc 
	 */
	public void stop(){
		siteFileFetch.siteStop();
	}
	
	public void setPause(boolean pause) {
		this.pause = pause;
		if(null != siteFileFetch) {
			siteFileFetch.setPause(pause);
		}
	}
	
	/**
	 * @Description: 获取文件下载进度 %
	 * @author mazc
	 * @return 
	 */
	public int getherLoadProgress(){
		return siteFileFetch.gatherLoadProgress();
	}
	
	/**
 	 * @Description: 获取下载速度
 	 * @author mazc
 	 * @return 
 	 */
 	public String getDownloadSpeed(){
 		return siteFileFetch.getDownloadSpeed();
 	}
 	
	/**
 	 * @Description: 获取剩余时间
 	 * @author mazc
 	 * @return 
 	 */
 	public String getRemainingTimeCurrent(){
 		return siteFileFetch.getRemainingTimeCurrent();
 	}
 	
 	/**
 	 * @Description: 校验文件是否一致
 	 * @author mazc
 	 * @return 
 	 */
 	public boolean getFileMD5(){
 		return siteFileFetch.MD5check();
 	}  	
 	
 	public SiteFileFetch getSiteFileFetch() {
 		return siteFileFetch;
 	}
}
