package com.gx.obe.common.file.inter;

import java.util.concurrent.ExecutorService;

import com.gx.obe.common.file.listener.DownloadListener;
import com.gx.obe.common.file.listener.IFileDownload;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

public interface IFileDownloadProject {

	/**
	 * @Description: 添加正在下载文件项
	 * @author chenxw
	 * @param tenderProjectEntity
	 * @param supplierList
	 * @param BIDOPENING_STAGE
	 * @param downloadType
	 * @param executorService
	 * @param downloadListener
	 */
	public void addIFileDownloading(TenderProjectEntity tenderProject, Supplier supplier, String BIDOPENING_STAGE, String downloadType, ExecutorService executorService, DownloadListener downloadListener);

	/**
	 * @Description: 添加已下载文件项
	 * @author chenxw
	 * @param tenderProjectEntity
	 * @param iFileDownload
	 */
	public void addIFileDownloaded(TenderProjectEntity tenderProject, IFileDownload iFileDownload);

	/**
	 * @Description: 是否关闭
	 * @author chenxw
	 * @return
	 */
	public boolean isStop();

	/**
	 * @Description: 删除正在下载文件项
	 * @author chenxw
	 * @param iFileDownload
	 */
	public void removeIFileDownload(IFileDownload iFileDownload);

	/**
	 * @Description: 关闭所有下载任务
	 * @author chenxw 
	 */
	public void closeDownloadTask();
}
