package com.gx.obe.common.file.listener;

import com.gx.obe.common.file.shell.FileDownloadShell.DownListener;
import com.gx.obe.web.entity.Supplier;

public interface IFileDownload {

	/**
	 * @Description: 开始下载
	 * @author chenxw
	 */
	// public void start();

	/**
	 * @Description: 添加主监听
	 * @author chenxw
	 * @param mainDownListener 
	 */
	public void addMainDownloadListener(DownListener mainDownListener);
	
	/**
	 * @Description: 获得下载文件的存放路径
	 * @author chenxw
	 * @return
	 */
	public String getBidFilePath();

	/**
	 * @Description: 获得下载文件名
	 * @author chenxw
	 * @return
	 */
	public String getFileName();

	/**
	 * @Description: 获得下载文件大小
	 * @author chenxw
	 * @return
	 */
	public String getFileSize();

	/**
	 * @Description:
	 * @author chenxw
	 */
	public void dispose();

	/**
	 * @Description: 获得下载用时
	 * @author chenxw
	 * @return
	 */
	public String getDownloadTime();

	/**
	 * @Description: 关闭下载任务
	 * @author chenxw 
	 */
	public void closeDownloadTask();
	
	/**
	 * @Description: 获取供应商
	 * @author chenxw 
	 */
	public Supplier getSupplier();
	
	/**
	 * @Description: 获取开标阶段
	 * @author chenxw 
	 */
	public String getBidopeningStage();
}
