package com.gx.obe.common.file.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.components.core.Constants;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.web.entity.FileInfoEntity;
import  com.gx.obe.web.utils.NetworkRequest;
import com.gx.obe.web.utils.ResultStatus;

public class BidFileUploadService {
	
	private Logger logger = Logger.getLogger(BidFileUploadService.class);

	static final String URL = "bidFileUploader";
	
	public int getFileNumber(String tenderId,String supplierId){
		String strWebServerUrl = Constants.getServiceUrl( URL + "/getFileNumber");
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tenderId", tenderId);
		param.put("supplierId", supplierId);
		param.put("type", FileConstants.BID_FILE_FOLDER);
		try {
			String result = NetworkRequest.get(strWebServerUrl,param);
			if(ResultStatus.isReultStatusInteger(result)){	
 				return Integer.valueOf(result);
 			}
			return 0;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return 0;
		}	
	}
	public List<FileInfoEntity> getBidFile(String tenderId ,String supplierId) { 
		String strWebServerUrl = Constants.getServiceUrl(URL + "/getBidFile");
		Map<String, Object> param = new HashMap<String, Object>();       
		param.put("tenderId",tenderId);
		param.put("supplierId",supplierId);
		param.put("fileType",FileConstants.BID_FILE_FOLDER);
         
		try {
			String result = NetworkRequest.post(strWebServerUrl, param);
			if(ResultStatus.getReultStatusIsNotEmpty(result)){
				return JsonUtil.jsonToList(result, FileInfoEntity.class);
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	public List<FileInfoEntity> getBiddingFile(String tenderId ) { 
		String strWebServerUrl = Constants.getServiceUrl(URL + "/getBidFile");
		Map<String, Object> param = new HashMap<String, Object>();       
		param.put("tenderId",tenderId);
 		param.put("fileType",FileConstants.BIDDING_FILE_FOLDER);
         
		try {
			String result = NetworkRequest.post(strWebServerUrl, param);
			if(ResultStatus.getReultStatusIsNotEmpty(result)){
				return JsonUtil.jsonToList(result, FileInfoEntity.class);
			}
			return null;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
}
