package com.gx.obe.common.file.service;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.gx.obe.common.file.upload.FileChunk;
import com.gx.obe.components.core.Constants;
import com.gx.obe.http.HttpResponse;
import com.gx.obe.http.Status;
import com.gx.obe.http.json.JsonUtil;
import  com.gx.obe.web.utils.NetworkRequest;
import com.gx.obe.web.utils.ResultStatus;

/** 
 * @Description: 
 * @author mazc 
 */
public class UploadFileService {
	
	static final String URL = "uploader";
	
	private Logger logger = Logger.getLogger(UploadFileService.class);
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param fileName
	 * @param tenderId
	 * @param supplierId
	 * @param type
	 * @return  true 文件存在  false 文件不存在
	 */
	public boolean checkFileisExists(String fileName , String tenderId ,String supplierId,String type){
		String strWebServerUrl = Constants.getServiceUrl(URL +"/checkFile");
		try{
			Map<String, Object> param = new HashMap<String, Object>();       
        	param.put("tenderId",tenderId);
        	param.put("supplierId",supplierId);
        	param.put("fileType",type);
        	param.put("filename", fileName);
         	HttpResponse strResult = NetworkRequest.postHttpResponse(strWebServerUrl, param);
        	if(strResult.getStatus()== Status.HTTP_OK){
        		return ResultStatus.getReultStatusBoolean(strResult.body());
        	}
			return false;
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
			return false;
		}
	}
	
	
	public boolean checkFileChunkMD5(FileChunk fileChunk){
		String strWebServerUrl = Constants.getServiceUrl(URL +"/checkFileMD5");
		String strResult = NetworkRequest.post(strWebServerUrl, JsonUtil.jsonObjectToStr(fileChunk));
    	return ResultStatus.getReultStatusBoolean(strResult);
	}
	
	
}
