package com.gx.obe.common.file.thread;

import java.util.List;

import org.apache.log4j.Logger;

import com.gx.obe.common.file.service.BidFileUploadService;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.FileInfoEntity;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

/**
 * 
 * 
 * @author  mazc
 * @Description: 检查文件是否存在
 *
 */
public class CheckServiceBidFileThread implements Runnable{
	private BidFileUploadService bidFileUploadService ;
	private TenderProjectEntity tenderProject;
	private Supplier supplier;
	private CheckCallBack checkCallBack;
	private Thread thread = null;
	private Logger LOG = Logger.getLogger(CheckServiceBidFileThread.class);
	
	public CheckServiceBidFileThread(TenderProjectEntity tenderProject, Supplier suppier , CheckCallBack checkCallBack){
		this.tenderProject = tenderProject;
		this.supplier = suppier;
		this.checkCallBack = checkCallBack;
		bidFileUploadService = new BidFileUploadService();
	}
	
	public void start(){
		thread = new Thread(this);
		thread.setName(supplier.getSupplierName());
		thread.start();
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void stop(){
		if(null != thread){
			thread = null;
		}
	}
	public void run(){
		List<FileInfoEntity> fileInfoEntityList = bidFileUploadService.getBidFile(this.tenderProject.getId(),this.supplier.getId());
		if(null != fileInfoEntityList && fileInfoEntityList.size() > 0) {
			long bidFileSize = 0;
			for(FileInfoEntity fileInfoEntity : fileInfoEntityList) {
				bidFileSize = bidFileSize + fileInfoEntity.getFileSize();
			}
			checkCallBack.bidFile(true, Messages.UploadStatus_yes, bidFileSize,fileInfoEntityList);
		}else {
			checkCallBack.bidFile(false, Messages.UploadStatus_no,0,fileInfoEntityList);
		}
	}
	
	public static interface CheckCallBack{
		public void bidFile(boolean isExist,String returnMessage,long fileSize ,List<FileInfoEntity> fileInfoEntityList);
 	}
}
