package com.gx.obe.common.file.utils;

import java.util.Optional;

import com.gx.obe.components.core.Constants;
import com.gx.obe.util.utils.StringUtils;

public class BidFileUtils {

	/**
	 * @Description: 获得投标文件文件名
	 * @author chenxw
	 * @param fileItem
	 * @param isEnc
	 * @return
	 */
	public static Optional<String> getBidFileName(String fileId, String fileName) {
		Optional<String> suffix = Optional.ofNullable(fileId).map(FileUtils::removeFileNameENC).map(FileUtils::getFileNameBack).filter(t -> {
			return !Constants.ZIP.equals(t);
		});
		return Optional.ofNullable(fileName).map(FileUtils::getFileNameFront).map(t -> t.concat(suffix.orElse(""))).filter(StringUtils::isNotEmpty);
	}
	
}
